#!/usr/bin/perl

#
# convert latex .dxi files into tex files (to print the index)
#

#
# First we sort the lines.
#
while(<>) { $line[$i++] = $_; };

@line = sort myorder @line;

print "\\begin{theindex}\n";

for($i = 0; $i <= $#line; $i++) {

	$_ = $line[$i];
	$bf = 0;

	/^\\indexentry{(.*)}{(\d*)}$/ && do {

		# Get the tab and page

		($tag, $page) = ($1, $2);
		#print "$tag, $page\n";

		# If the tag ends with _, must be print as boldface

		if ($tag =~ /_$/) {
			$bf = 1;
			chop($tag);
		}

		# Do we have a sub item (items are separated by a '.')
		# Be carefull not to split \.

		$tag =~ s/\\\./\$\$/g;
		($item, $subitem) = split(/\./, $tag);
		# change back \. to .
		$item =~ s/\$\$/./g;
		$subitem =~ s/\$\$/./g;

		# Change _ to \_

		$item =~ s/([^\\])_/$1\\_/g;
		$subitem =~ s/([^\\])_/$1\\_/g;


		# If we have a subitem ....

		if ($subitem) {

			# End the item is a new one, create a empty item

			if ($item ne $olditem) {

				&blankLine();
				print "\\item ", &bfTag($item), "\n";
				$olditem = $item;

			}

			# Print the subitem

			print "    \\subitem ", &bfTag($subitem), " $page\n";

		} else {

			# Just print the item

			&blankLine();
			print "\\item ", &bfTag($item), " $page\n";

		}
	};
}

print "\\end{theindex}\n";

sub bfTag {
	local($tag) = $_[0];

	if ($bf) {
		"{\\bf $tag}";
	} else {
		$tag;
	}
}

# Decide to print a blank line if $item begins with a new leter.

sub blankLine {

	# Get the first 'usefull' letter

	$a = $item;
	$a =~ s/^{\\.. //;
	$a = substr($a, 0, 1);
	$a =~ tr/A-Z/a-z/;

	if ($oldStartLetter && $oldStartLetter ne $a) {
		print "\\indexspace\n";
	}
	$oldStartLetter = $a;
}

# Sort the lines by alphabetic order

sub myorder {
	($aa, $bb) = ($a, $b);

	# Remove the \indexentry{}

	$aa =~ s/^\\indexentry{//;
	$aa =~ s/}$//;
	$bb =~ s/^\\indexentry{//;
	$bb =~ s/}$//;

	# Remove any {\xx }

	$aa =~ s/{\\.. ([^}]*)}/\1/g;
	$bb =~ s/{\\.. ([^}]*)}/\1/g;

	# Lower case

	$aa =~ tr/A-Z/a-z/;
	$bb =~ tr/A-Z/a-z/;

	# Now compare...
#print "+++ $aa --- $bb\n";

	$aa cmp $bb;
}
