/*
 * Copyright (c) 1996 The Regents of the University of Michigan
 * All Rights Reserved
 * 
 * License to use, copy, modify, and distribute this software and its
 * documentation can be obtained from Merit at the University of Michigan.
 * 
 * Merit GateDaemon Project
 * 4251 Plymouth Road, Suite C
 * Ann Arbor, MI 48105
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE REGENTS OF THE
 * UNIVERSITY OF MICHIGAN AND MERIT DO NOT WARRANT THAT THE
 * FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR
 * THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. The Regents of the
 * University of Michigan and Merit shall not be liable for
 * any special, indirect, incidental or consequential damages with respect
 * to any claim by Licensee or any third party arising from use of the
 * software. GateDaemon was originated and developed through release 3.0
 * by Cornell University and its collaborators.
 * 
 * Please forward bug fixes, enhancements and questions to the
 * gated mailing list: gated-people@gated.merit.edu.
 * 
 * This copyright has ben automaticly added by the util/addcopyright.pl program.
 * __END_OF_COPYRIGHT__
 */

#ifndef _dll_h
#define _dll_h
/*
 *	Generic doubly-linked list manipulation macros
 */
typedef struct _DLList {
	struct _DLList *forw, *back;
} DLList;

/* Iterate forward through the DLList */
#define IterateDLListForw(ptr, head, cast)\
	for (ptr = (cast)((head)->forw); \
		ptr != (cast)((head)); \
		ptr = ((cast)((DLList *)ptr)->forw))

/* Iterate backward through the DLList */
#define IterateDLListBack(ptr, head, cast)\
	for (ptr = (cast)((head)->back); \
		ptr != (cast)((head)); \
		ptr = ((cast)((DLList *)ptr)->back))

/* return the next item forward */
#define DLListForw(elem, cast)\
	((cast)(((DLList *)(elem))->forw))

/* return the next item backward */
#define DLListBack(elem, cast)\
	((cast)(((DLList *)(elem))->back))

/* return next item forward, or NULL if at end of list */
#define DLListNext(elem, head, cast)\
	((DLListForw(elem, DLList *) == head) ? ((cast)(NULL)) : (DLListForw(elem, cast)))

/* return next item backward, or NULL if at end of list */
#define DLListPrev(elem, head, cast)\
	((DLListBack(elem, DLList *) == head) ? ((cast)(NULL)) : (DLListBack(elem, cast)))

#define DLListEmpty(head)\
	(((DLList *)head)->forw == head)

#define DLLInsque(elem, prev)\
	INSQUE(elem, prev);

#define DLLRemque(elem)\
	REMQUE(elem);

#define DLLInit(links)\
	((links)->forw = (links)->back = (DLList *)(links))

#endif 	/* _dll_h */


