/*
 * Copyright (c) 1996 The Regents of the University of Michigan
 * All Rights Reserved
 * 
 * License to use, copy, modify, and distribute this software and its
 * documentation can be obtained from Merit at the University of Michigan.
 * 
 * Merit GateDaemon Project
 * 4251 Plymouth Road, Suite C
 * Ann Arbor, MI 48105
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE REGENTS OF THE
 * UNIVERSITY OF MICHIGAN AND MERIT DO NOT WARRANT THAT THE
 * FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR
 * THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. The Regents of the
 * University of Michigan and Merit shall not be liable for
 * any special, indirect, incidental or consequential damages with respect
 * to any claim by Licensee or any third party arising from use of the
 * software. GateDaemon was originated and developed through release 3.0
 * by Cornell University and its collaborators.
 * 
 * Please forward bug fixes, enhancements and questions to the
 * gated mailing list: gated-people@gated.merit.edu.
 * 
 * This copyright has ben automaticly added by the util/addcopyright.pl program.
 * __END_OF_COPYRIGHT__
 */

#ifndef _trace_h
#define _trace_h

/*
 *	Trace events
 */

typedef struct {
	u_int	flags;
	FILE	*fp;
} Logger;

#define	T_ISISALL	0xffff
#define	T_DUMPIIH	0x0001
#define T_DUMPLSP	0x0002
#define T_EVENTS	0x0004
#define	T_LANADJ	0x0008
#define T_FLOODING	0x0010
#define	T_BUILDLSP	0x0020
#define	T_CSNP		0x0040
#define	T_PSNP		0x0080
#define	T_LSPINPUT	0x0100
#define	T_P2PADJ	0x0200
#define T_TRSPF		0x0400
#define T_DUMPDB	0x0800
#define T_ROUTE1 	0x1000 		/* route changes only */
#define T_ROUTE2 	0x2000 		/* all routes; 1st hop only */
#define T_ROUTE3 	0x4000 		/* all routes + path back from dest */
#define T_LSPCONTENT 	0x8000 		/* dump contents of LSPs */

#define IFTRACE(t) if (debugLog.flags & (t)) {
#define ENDTRACE	}

#endif 	/* _trace_h */

