/*
 * Copyright (c) 1996 The Regents of the University of Michigan
 * All Rights Reserved
 * 
 * License to use, copy, modify, and distribute this software and its
 * documentation can be obtained from Merit at the University of Michigan.
 * 
 * Merit GateDaemon Project
 * 4251 Plymouth Road, Suite C
 * Ann Arbor, MI 48105
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE REGENTS OF THE
 * UNIVERSITY OF MICHIGAN AND MERIT DO NOT WARRANT THAT THE
 * FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR
 * THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. The Regents of the
 * University of Michigan and Merit shall not be liable for
 * any special, indirect, incidental or consequential damages with respect
 * to any claim by Licensee or any third party arising from use of the
 * software. GateDaemon was originated and developed through release 3.0
 * by Cornell University and its collaborators.
 * 
 * Please forward bug fixes, enhancements and questions to the
 * gated mailing list: gated-people@gated.merit.edu.
 * 
 * This copyright has ben automaticly added by the util/addcopyright.pl program.
 * __END_OF_COPYRIGHT__
 */

#define	INCLUDE_FILE
#define	INCLUDE_IOCTL
#include "include.h"
#ifdef	PROTO_INET
#include "inet.h"
#endif	/* PROTO_INET */
#ifdef	PROTO_INET6
#include "inet6.h"
#endif	/* PROTO_INET6 */
#include "krt.h"
#include "krt_var.h"
#include <stdio.h>


int
krt_symbols __PF1(tp, task *)
{
    char *resp;
    char buf[240];
    FILE *fp;

#ifdef	PROTO_INET
    resp = (char *) fp = fopen("/proc/net/snmp","r");
    if (fp) {
	resp = fgets(buf, 240, fp);      /* skip header */
	resp = fgets(buf, 6, fp);
	resp += 4;                    /* point at IP Forwarding value */
	fclose (fp);
    }
    if (resp) {
	inet_ipforwarding = (atoi(resp) == 1);
	trace_tp(tp,
		 TR_KRT_SYMBOLS,
		 0,
		 ("krt_symbols: IP forwarding: %u using %u\n",
		  atoi(resp),
		  inet_ipforwarding));
    }
#endif	/* PROTO_INET */

#ifdef	PROTO_INET6
    fp = fopen("/proc/net6/snmp6","r");
    if (fp) {
	resp = fgets(buf, 240, fp);      /* skip header */
	resp = fgets(buf, 6, fp);
	fclose (fp);

	resp += 4;                    /* point at IPv6 Forwarding value */
	inet6_ipforwarding = (atoi(resp) == 1);  /* 1 == forward on *
						  * 2 == forward off */

	trace_tp(tp,
		 TR_KRT_SYMBOLS,
		 0,
		 ("krt_symbols: IPv6 forwarding: %u using %u\n",
		  atoi(resp),
		  inet6_ipforwarding));
      }
#endif	/* PROTO_INET6 */

    fp = fopen("/proc/version","r");                   
    if (fp) {                                                  
        krt_version_kernel = task_mem_strdup(tp, fgets(buf, 80, fp));
        fclose (fp);                                                      
    }                                                                   

    trace_tp(tp,
	     TR_KRT_SYMBOLS,
	     0,
	     ("krt_symbols: krt_version_kernel = %s",
	      krt_version_kernel));
    return 0;
}


