/*
 * Copyright (c) 1996 The Regents of the University of Michigan
 * All Rights Reserved
 * 
 * License to use, copy, modify, and distribute this software and its
 * documentation can be obtained from Merit at the University of Michigan.
 * 
 * Merit GateDaemon Project
 * 4251 Plymouth Road, Suite C
 * Ann Arbor, MI 48105
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE REGENTS OF THE
 * UNIVERSITY OF MICHIGAN AND MERIT DO NOT WARRANT THAT THE
 * FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR
 * THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. The Regents of the
 * University of Michigan and Merit shall not be liable for
 * any special, indirect, incidental or consequential damages with respect
 * to any claim by Licensee or any third party arising from use of the
 * software. GateDaemon was originated and developed through release 3.0
 * by Cornell University and its collaborators.
 * 
 * Please forward bug fixes, enhancements and questions to the
 * gated mailing list: gated-people@gated.merit.edu.
 * 
 * This copyright has ben automaticly added by the util/addcopyright.pl program.
 * __END_OF_COPYRIGHT__
 */

/* Generic double linked list structure
 */
typedef struct _list_t {
        struct _list_t *l_prev;
        struct _list_t *l_next;
} list_t;

#define LIST_REM(start, elm) { \
        if (((list_t *)elm)->l_next) \
                ((list_t *)elm)->l_next->l_prev = ((list_t *)elm)->l_prev; \
        if (((list_t *)elm)->l_prev) \
                ((list_t *)elm)->l_prev->l_next = ((list_t *)elm)->l_next; \
        if (((list_t *)start) == ((list_t *)elm)) \
                ((list_t *)start) = ((list_t *)elm)->l_next; \
}

#define LIST_ADD(start, elm) { \
        ((list_t *)elm)->l_prev = (list_t *)NULL; \
        ((list_t *)elm)->l_next = ((list_t *)start); \
        if (((list_t *)elm)->l_next) \
                ((list_t *)elm)->l_next->l_prev = ((list_t *)elm); \
        ((list_t *)start) = ((list_t *)elm); \
}

#define LIST_ADD_LAST(start, elm) { \
	list_t *l; \
	if (!((list_t *)(start))) { \
		((list_t *)start) = ((list_t *)elm); \
		((list_t *)elm)->l_prev = NULL; \
	} \
	else { \
		for(l = ((list_t *)start); l->l_next; l = l->l_next); \
		l->l_next = ((list_t *)elm); \
		((list_t *)elm)->l_prev = l; \
	} \
	((list_t *)elm)->l_next = NULL; \
}

#define LIST_INSERT(prev, elm) { \
	((list_t *)elm)->l_next = ((list_t *)prev)->l_next; \
	((list_t *)elm)->l_prev = ((list_t *)prev); \
	if (((list_t *)elm)->l_next) \
		((list_t *)elm)->l_next->l_prev = ((list_t *)elm); \
	((list_t *)prev)->l_next = ((list_t *)elm); \
}
	

#define MALLOC(new, type, size, msg) { \
        if (((new) = (type)malloc((size))) == NULL) \
                PrintError(EXT, EXIT, "Malloc failed for %s", (msg)); \
}

#define FREE(new, size, msg) { \
        free((char *)(new)); \
}

#define REALLOC(new, type, oldsize, newsize, msg) { \
        if (((new) = (type)realloc((new), (newsize))) == NULL) \
                PrintError(EXT, EXIT, "Realloc failed for %s", (msg)); \
}

