/*
 * DRET-IPv6
 *
 * Contacts:	
 *              INRIA      <Christophe.Diot@sophia.inria.fr>
 *              MASI       <Eric.Horlait@masi.ibp.fr>
 *              This software has been developped with the financial support
 *              of DRET (French Military Research Agency).
 *
 * Version:    $Id: inet6.h,v 1.5 1996/12/18 10:57:49 eh Exp $ 
 *	
 * Authors:	
 *	        Frank Zago
 *
 * Description:
 *
 *              inet6.h is derived from inet.h
 *
 *		This program is free software; you can redistribute it and/or
 *		modify it under the terms of the GNU General Public License
 *		as published by the Free Software Foundation; either version
 *		2 of the License, or (at your option) any later version.
 *              This notice must be copied with the distributed package.
 *
 */				

extern int sock_inet6;		/* AF_INET6 socket for several usages */

/* macros to select inet6 address given pointer to a struct sockaddr_un */

/* clear and init a sockaddr_un for inet6 use */
#define	sock2in6(x)	((x)->in6.gin6_addr)
#define	sock2ip6(x)	(sock2in6(x).s6_addr)
#define	sock2port6(x)	((x)->in6.gin6_port)
#define	sock2plen6(x)	((x)->in6.gin6_plen)
#define	sock2flow6(x)	((x)->in6.gin6_flowinfo)

#define	SOCKADDR_IN6_LEN  (sizeof (inet6_addr_any->in6))

/* IPv6 maximum packet size */
#ifndef	IPV6_MAXPACKET
#define	IPV6_MAXPACKET	65535
#endif

/* RIPng max packet size */
#define RIPNG_PKTSIZE (IPV6_MAXPACKET- sizeof(struct ipv6hdr)- sizeof(struct udphdr))

extern int inet6_ipforwarding;		/* IPv6 forwarding engine */

/* Common addresses */
extern sockaddr_un *inet6_addr_loopback;
extern sockaddr_un *inet6_addr_any;
extern sockaddr_un *inet6_addr_reject;
extern sockaddr_un *inet6_addr_blackhole;
extern sockaddr_un *inet6_addr_allhosts;
extern sockaddr_un *inet6_addr_allrouters;

extern struct in6_addr IN6ADDR_DEFAULT;
extern struct in6_addr IN6ADDR_LOOPBACK;
extern struct in6_addr INET6_ADDR_ALLHOSTS;
extern struct in6_addr INET6_ADDR_ALLROUTERS;

/* Type of IPv6 adresses */
#define INET6_ADDR_UNASSIGNED 1
#define INET6_ADDR_ANY        2
#define INET6_ADDR_LOOPBACK   4 
#define INET6_ADDR_IP4COMP    8
#define INET6_ADDR_UNICAST    16 /* unicast adress (geographic or provider) */
#define INET6_ADDR_MCAST      32
#define INET6_ADDR_LINKLOCAL  64
#define INET6_ADDR_SITE_LOCAL 128
	
extern task *inet6_task;

PROTOTYPE(inet6_family_init,
	  extern void,
	  (void));

PROTOTYPE(inet6_var_init,
	  extern void,
	  (void));

PROTOTYPE(inet6_init,
	  extern void,
	  (void));

PROTOTYPE(inet6_get_addr_type,
	  extern int,
	  (struct in6_addr *, 
	  unsigned int));

PROTOTYPE(sockaddrcmp_in6,
	  int,
	  (sockaddr_un *,
	   sockaddr_un *));

PROTOTYPE(sockaddrcmp2_in6,
	  extern int,
	  (sockaddr_un *,
	   sockaddr_un *,
	   int));
