typedef union {
    long	num;
    u_long	u_num;
    bytestr	hex;
    charstr	str;
    flag_t	flag;
    time_t	time;
    utime_t	utime;
    as_t	as;
    proto_t	proto;
    pmet_t	metric;
    pref_t	pref;
    if_addr	*ifap;
    if_addr_entry	*ifae;
    adv_entry	*adv;
    gw_entry	*gwp;
    void_t	vt;
    sockaddr_un	*sockaddr;
    trace_file	*trace_file;
#ifdef	PROTO_INET
    struct in_addr in_addr;
#endif	/* PROTO_INET */
#ifdef	PROTO_INET6
    struct in6_addr in6_addr;
#endif	/* PROTO_INET6 */
    dest_mask	dm;
    struct {
	pmet_t metric;
	adv_entry *adv;
    } metric_adv ;
    struct {
	proto_t proto;
	adv_entry **import_list;
	adv_entry **export_list;
	gw_entry **gw_list;
    } proto_lists;
    config_entry *config;
    config_list *conflist;
#ifndef	GATED_LEXER
#ifdef	PROTO_OSPF
    ospf_config_router *ospf_router;
#endif	/* PROTO_OSPF */
#ifdef	PROTO_ASPATHS
    as_path *aspath;
    asmatch_t *asp_match;
    asp_range asp_range;
    asp_stack asp_stack;
#endif	/* PROTO_ASPATHS */
#endif	/* GATED_LEXER */
} YYSTYPE;
#define	L_EOS	258
#define	L_ERROR	259
#define	L_NUMBER	260
#define	L_STRING	261
#define	L_HNAME	262
#define	L_KEYWORD	263
#define	L_HEXSTRING	264
#define	L_OCTETSTRING	265
#define	L_INET6ADDR	266
#define	T_DIRECT	267
#define	T_INTERFACE	268
#define	T_INTERFACES	269
#define	T_LCLADDR	270
#define	T_PROTO	271
#define	T_METRIC	272
#define	T_METRICIN	273
#define	T_METRICOUT	274
#define	T_INFINITY	275
#define	T_DOWN	276
#define	T_PARSE	277
#define	T_ADV	278
#define	T_DEFAULT	279
#define	T_DEFAULTS	280
#define	T_YYDEBUG	281
#define	T_YYSTATE	282
#define	T_YYQUIT	283
#define	T_DEBUG	284
#define	T_SYSLOG	285
#define	T_UPTO	286
#define	T_EMERG	287
#define	T_ALERT	288
#define	T_CRIT	289
#define	T_ERR	290
#define	T_WARNING	291
#define	T_NOTICE	292
#define	T_INFO	293
#define	T_ON	294
#define	T_OFF	295
#define	T_GATEWAY	296
#define	T_PREFERENCE	297
#define	T_PREFERENCE2	298
#define	T_DEFAULTMETRIC	299
#define	T_NONBROADCAST	300
#define	T_BROADCAST	301
#define	T_TYPE	302
#define	T_POINTOPOINT	303
#define	T_MULTICAST	304
#define	T_NETMASK	305
#define	T_DEFINE	306
#define	T_INTERNAL	307
#define	T_EXTERNAL	308
#define	T_IGNORE	309
#define	T_NOP	310
#define	T_NOP1	311
#define	T_NOP_DM	312
#define	T_NOP_ADV	313
#define	T_NOP_PROTO	314
#define	T_NOP_SOCKADDR	315
#define	T_PEERAS	316
#define	T_LOCALAS	317
#define	T_NEIGHBOR	318
#define	T_GROUP	319
#define	T_NOGENDEFAULT	320
#define	T_VERSION	321
#define	T_ACQUIRE	322
#define	T_TTL	323
#define	T_EGP	324
#define	T_KERNEL	325
#define	T_SYMBOLS	326
#define	T_REMNANTS	327
#define	T_IFLIST	328
#define	T_ROUTES	329
#define	T_NOCHANGE	330
#define	T_NOFLUSHATEXIT	331
#define	T_REMNANTHOLDTIME	332
#define	T_HIGHER	333
#define	T_LOWER	334
#define	T_FLASH	335
#define	T_INTERIOR	336
#define	T_BACKGROUND	337
#define	T_LIMIT	338
#define	T_TRUSTEDGATEWAYS	339
#define	T_SOURCEGATEWAYS	340
#define	T_RIP	341
#define	T_RIPNG	342
#define	T_RIPNGOUT	343
#define	T_NORIPNGOUT	344
#define	T_RIPNGIN	345
#define	T_NORIPNGIN	346
#define	T_TUNNEL	347
#define	T_AREA	348
#define	T_SPF	349
#define	T_HELLO	350
#define	T_HELLOINTERVAL	351
#define	T_ROUTERDEADINTERVAL	352
#define	T_PRIORITY	353
#define	T_ENABLE	354
#define	T_DISABLE	355
#define	T_QUERY	356
#define	T_QUERYINTERVAL	357
#define	T_MODE	358
#define	T_ADVERTISE	359
#define	T_REGISTER	360
#define	T_SNMP	361
#define	T_REDIRECT	362
#define	T_REDIRECTS	363
#define	T_NOREDIRECTS	364
#define	T_AUTHTYPE	365
#define	T_AUTHKEY	366
#define	T_NONE	367
#define	T_SIMPLE	368
#define	T_AUTH	369
#define	T_MD5	370
#define	T_SECONDARY	371
#define	T_PASSIVE	372
#define	T_SIMPLEX	373
#define	T_STRICTIFS	374
#define	T_SCANINTERVAL	375
#define	T_STATIC	376
#define	T_MARTIANS	377
#define	T_RETAIN	378
#define	T_EXPORT	379
#define	T_IMPORT	380
#define	T_EXACT	381
#define	T_REFINE	382
#define	T_HOST	383
#define	T_MASK	384
#define	T_MASKLEN	385
#define	T_REJECT	386
#define	T_BLACKHOLE	387
#define	T_RESTRICT	388
#define	T_ALLOW	389
#define	T_ANNOUNCE	390
#define	T_LISTEN	391
#define	T_AS	392
#define	T_ROUTERID	393
#define	T_IGP	394
#define	T_OPTIONS	395
#define	T_NOINSTALL	396
#define	T_NOSEND	397
#define	T_NORESOLV	398
#define	T_MARK	399
#define	T_TRACEOPTIONS	400
#define	T_EXCEPT	401
#define	T_REPLACE	402
#define	T_SIZE	403
#define	T_FILES	404
#define	T_K	405
#define	T_M	406
#define	T_ALL	407
#define	T_ROUTE	408
#define	T_STATE	409
#define	T_POLICY	410
#define	T_NORMAL	411
#define	T_GENERAL	412
#define	T_TASK	413
#define	T_TIMER	414
#define	T_NOSTAMP	415
#define	T_UPDATE	416
#define	T_DETAIL	417
#define	T_SEND	418
#define	T_RECEIVE	419
#define	T_ERROR	420
#define	T_PACKETS	421
#define	T_RESPONSE	422
#define	T_REQUEST	423
#define	T_OTHER	424
#define	T_TRAP	425
#define	L_USEC	426
#define	T_AGGREGATE	427
#define	T_GENERATE	428
#define	T_BRIEF	429
#define	T_INET6	430


extern YYSTYPE yylval;
