:
eval 'exec perl $0 ${1+"$@"}'
	if 0;

#
# The include and other files we need to generate
#
$define_file = 'defines.h';
$path_file   = 'paths.h';
$parser_file = 'parser.y';
$file_file = 'files';
$Makefile_file = 'Makefile';
$template = 'templ';
$signame_file = 'signames.c';
$source_version = 'VERSION';
$version_file = 'version.c';
$configDir = 'configs';
$defaultConfigFile = 'DEFAULT';
$logFile = "autoconf.log";

# where to look for <signal.h>

@includeDir = ('/usr/include', '/usr/include/sys', '/usr/include/net',
	'/usr/include/netinet', '/usr/include/arpa', '/usr/include/protocols');

# Libraries

@libDir = ('/lib', '/usr/lib', '/usr/local/lib');
@libFiles = ('c', 'kvm', 'resolv', 'socket', 'nsl', 'alloca', 'util', 'bsd',
	'm');

# Where to look for commands

@path = split(/:/, $ENV{"PATH"});
@extraPath = ('/bin', '/sbin', '/etc', '/usr/bin', '/usr/sbin',
        '/usr/ucb', '/usr/etc', '/usr/local/bin', '/usr/local/sbin',
        '/usr/local/etc', '/usr/ccs/bin', '.', 'util');

# Where to look for the kernel

@path_unix = ('/vmunix', '/bsd', '/unix', '/hp-ux', '/kernel/unix',
	'/kernel/genunix');

# summary of all generated files

@generatedList = ($define_file, $path_file, $parser_file, $Makefile_file,
	$signame_file, $version_file, "parser.c", "lexer.c");

#
# List of protocol configurable and #define equivalent. if the fisrt
# member if configure, then the the item in the second member will generate
# #define statements.
#
%proto = (
	"hello",	"PROTO_HELLO PROTO_INET",
	"icmp", 	"PROTO_ICMP PROTO_INET",
	"rip", 		"PROTO_RIP PROTO_INET MD5_CHECKSUM",
	"ripng",	"PROTO_RIPNG PROTO_INET6",
	"ospf",		"PROTO_OSPF PROTO_INET PROTO_ASPATHS AUTONOMOUS_SYSTEM \
				ROUTER_ID FLETCHER_CHECKSUM MD5_CHECKSUM",
	"ospf2",	"PROTO_OSPF2 PROTO_INET PROTO_ASPATHS AUTONOMOUS_SYSTEM\
				ROUTER_ID FLETCHER_CHECKSUM MD5_CHECKSUM",
	"rdisc",	"PROTO_RDISC PROTO_INET PROTO_ICMP PARSE_LINK \
				ICMP_SEND",
	"egp", 		"PROTO_EGP PROTO_INET AUTONOMOUS_SYSTEM",
	"bgp", 		"PROTO_BGP PROTO_INET PROTO_ASPATHS AUTONOMOUS_SYSTEM \
				ROUTER_ID",
	"snmp",		"PROTO_SNMP PROTO_INET PARSE_PORT",
	"dvmrp",	"PROTO_DVMRP PROTO_INET PROTO_IGMP \
				IP_MULTICAST_ROUTING",
	"pim",		"PROTO_PIM PROTO_INET PROTO_IGMP IP_MULTICAST_ROUTING",
	"igmp",		"PROTO_IGMP PROTO_INET IP_MULTICAST_ROUTING",
	"gii",		"PROTO_GII PROTO_INET",
);

#
# All the commands we need. Those are the default
#
%unixCmd = (
	"cc",			"gcc:cc",
	"head",			"head",
	"install",		"install",
	"lex",			"flex:lex",
	"link",			"ln",
	"lint",			"lint",
	"mkdep",		"makedepend:mkdep",
	"yacc",			"bison:yacc",
	"ranlib",		"ranlib:/bin/true",
	"ar",			"ar",
	"tags",			"etags",
	"basename", 		"basename",
	"cat",			"cat",
	"chgrp",		"chgrp",
        "chmod",       		"chmod",
	"configure",		"configure.pl",
        "date",        		"date",
        "make",        		"make",
        "mv",          		"mv",
	"nm",			"nm",
        "rm",          	 	"rm",
        "sed",         		"sed",
        "size",        		"size",
        "tee",         		"tee",
        "touch",       		"touch",
	"uname",		"uname",
	"isode_snmpi",		"snmpi",
	"isode_mosy",		"mosy",
	"isode_snmp_defs_c",
		"\${ISODE_SNMPI} -f gated-mib.defs compile -s gated-mib",
	"isode_snmp_c_o",	"\${CC} -c \${CFLAGS} \${IFLAGS} gated-mib.c"
);

#
# All the flags for diferent commands
#
%cmdFlags = (
	"cflags", 		"-O -Wall -g",
	"installflags",		"-c -s",
	"ldflags",		'',
	"lflags",		"-v",
	"lintflags",		"-hxz",
	"yflags",		"-d",
	"tflags",		'',
	"cwflags",		'',
	"ldothers",		'',
	"lnflags",		'-s'
);

#
# Default directory and file names for installing stuff...
#
%dirPath = (
	"bindir",		"/etc",
	"sbindir",		"/sbin",
	"destdir",		"",
	"objdir",		"obj",
	"signal_h",		"",
	"template",		"Makefile.temp",
	"compatdir",		"compat",
	"srcdir",		"..",
	"smandir",		"../man",
	"mandir",		"/usr/man",
	"mibdir",		"mib",
	"utildir",		"util",
	"gated",		"gated",
	"gdc",			"gdc",
	"ripquery",		"ripquery",
	"ospf_monitor",		"ospf_monitor",
	"isode_snmp_include",	"/usr/include/isode/snmp"
);

#
# Other usefull declarations
#
%miscParam = (
	"mantype",	"bsd42",
	"ospfm_mode",	"4755",
	"ospfm_user",	"root",
	"config_mode",	"0664",
	"gdc_mode",	"4750",
	"gdc_group",	"gdmaint"
);

#
# Path used at run time (hard coded in gated)
#
%runtimePath = (
	"path_config",		"/etc/%s.conf",
	"path_dump",		"/usr/tmp/%s_dump",
	"path_dumpdir",		"/usr/tmp",
	"path_pid",		"/etc/%s.pid",
	"path_version",		"/etc/%s.version",
	"path_unix",		"/vmunix",
	"path_defs",		"/usr/include/isode",
);

#
# List of default options
#
%options = (
	"ENVIRON",		"environ",
        "IBM_6611",		0,
	"GDC_RESOURCE",		0,
	"SUNOS5_0",		0,
        "KRT_IFR_MTU",		"ifr_mtu" ,
        "ISODE_SNMP_NODEFS",	0,
        "NEED_HERRNO",		0,
        "NEED_HERRS",		0,
        "NEED_FFS",		0,
        "NEED_SYSCONF",		0,
        "NEED_UNSETENV",	0,
        "NEED_STRCASECMP",	0,
        "NEED_STRERROR",	0,
        "NEED_INET_ATON",	0,
        "NEED_SIGNAME",		0,
        "NEED_SETVBUF",		0,
        "NEED_FLOCK",		0,
        "MIB_GATED",		0,
        "MIB_RIP",		0,
        "KRT_RTREAD_KMEM",	0,
        "KRT_RTREAD_KINFO",	0,
        "KRT_RTREAD_PROC",	0,
        "KRT_RTREAD_RADIX",	0,
        "KRT_RTREAD_SUNOS5",	0,
        "KRT_IFREAD_IOCTL",	0,
        "KRT_IFREAD_KINFO",	0,
        "KRT_RT_IOCTL",		0,
        "KRT_RT_SOCK",		0,
	"KRT_RT_NOCHANGE",	0,
        "KRT_LLADDR_KMEM",	0,
        "KRT_LLADDR_LINUX",	0,
        "KRT_LLADDR_SUNOS4",	0,
        "KRT_LLADDR_SUNOS5",	0,
        "KRT_LLADDR_NONE",	0,
        "KRT_SYMBOLS_NLIST",	0,
        "KRT_SYMBOLS_PROC",	0,
        "KRT_SYMBOLS_SUNOS5",	0,
        "KRT_SYMBOLS_SYSCTL",	0,
        "KRT_NETOPTS",		0,
        "KRT_SOCKET_TYPE",	'PF_UNIX,SOCK_DGRAM,AF_UNSPEC',
	"KRT_IPMULTI_NOCACHE",	0,
	"KRT_IPMULTI_RTSOCK",	0,
	"KRT_IPMULTI_TTL0",	0,
        "KVM_TYPE_SUNOS4",	0,
        "KVM_TYPE_BSD44",	0,
        "KVM_TYPE_RENO",	0,
        "KVM_TYPE_OTHER",	0,
        "KVM_TYPE_NONE",	0,
        "SIGTYPE",		"void",
        "SIGRETURN",		"return",
        "VOID_T",		'void *',
        "GID_T",		'gid_t',
        "PID_T",		"pid_t" ,
        "KSYM_IPFORWARDING",	'"_ipforwarding"',
        "KSYM_UDPCKSUM",	'"_udpcksum"',
	"KSYM_IFNET",		'"_ifnet"',
	"KSYM_RADIXHEAD",	'"_radix_node_head"',
	"KSYM_RTHASHSIZE",      '"_rthashsize"',
	"KSYM_RTHOST",		'"_rthost"',
	"KSYM_RTNET",           '"_rtnet"',
	"KSYM_VERSION",		'"_version"',
        "U_INT8",		'unsigned char',
        "S_INT8",		"char",
        "U_INT16",		'unsigned short',
        "S_INT16",		"short",
        "U_INT32",		'unsigned int',
        "S_INT32",		"int",
        "U_INT64",		0,
        "S_INT64",		0,
        "__GATED__",		1,
        "LOG_OPTIONS",		'LOG_PID | LOG_CONS | LOG_NDELAY',
        "LOG_FACILITY",		"LOG_DAEMON" ,
        "LOCAL_VERSION",	0,
        "IFL_NAMELEN",		"16",
        "NLIST_T",		'struct nlist',
        "NLIST(fd,nl,sz)",	"nlist(fd,nl)",
        "GA2S(x)",		"((u_long)(void_t)(x))",
        "GS2A(x)",		"((void_t)(u_long)(x))",
	"RT_N_MULTIPATH",	0,
	"INET_CLASS_E",		0,
	"MIB_GATED",		0,
	"HPUX_7",		0,
	"SUNOS_5",		0,
	"SYSV",			0,
	"SYSVR4",		0,
	"_SC_PAGE_SIZE",	0,
	"ROUTES_WO_MBUFS",	0,
	"P2P_RT_REMOTE",	0,
	"VARIABLE_MASKS",	0,
	"SOCKET_LENGTHS",	0,
	"SOCKADDR_DL",		0,
	"INCLUDE_IF_DL",	0,
	"BSD_SIGNALS",		0,
	"SYSV_SIGNALS",		0,
	"POSIX_SIGNALS",	0,
	"HAVE_WAITPID",		0,
	"NO_STAT",		0,
	"NO_FORK",		0,
	"NO_IP_MULTICAST",	0,
	"HAVE_GETSYSTIMES",	0,
	"INCLUDE_UNISTD",	0,
	"INCLUDE_STRING",	0,
	"NO_MBUF_H",		0,
	"NO_STDDEF_H",		0,
	"NO_INCLUDE_TIME",	0,
	"INCLUDE_FCNTL",	0,
	"INCLUDE_TYPES",	0,
	"INCLUDE_BSDTYPES",	0,
	"USE_STREAMIO",		0,
	"INCLUDE_STREAMIO",	0,
	"USE_SYSCTL",		0,
	"INCLUDE_SOCKIO",	0,
	"INCLUDE_SIOCTL",	0,
	"ICMP_NOIP_HEADER",	0,
	"LINGER_NO_PARAM",	0,
	"INCLUDE_PATHS",	0,
	"NLIST_NOUNDER",	0,
	"USE_SETPGRP",		0,
	"SYS_SIGNAME",		0,
	"MUST_FFLUSH",		0,
	"FLAT_FS",		0,
	"UNDEF_RCVBUF",		0,
	"HAVE_DIRENT",		0,
	"BYTE_ORDER",		0,
	"RTBIT_SIZE",		0,
	"GDC_RESOURCE",		0,
	# Those do not need default since no default -> no #define defined.
	"bcmp(b1,b2,l)",	'',
	"bcopy(s,d,l)",		'',
	"bzero(s,l)",		'',
	"getpagesize()",	'',
	"getwd(path)",		'',
	"index",		'',
	"rindex",		'',
	"sigmask(m)",		'',
	"tzset()",		'',
	"tzsetwall()",		'',
	"tzsetwall()",		'',
	"ftruncate(f,o)",	'',
	# Auto generated from the protocol list.
	"MD5_CHECKSUM",		0,
	"PROTO_HELLO",		0,
	"PROTO_ICMP",		0,
	"PROTO_INET",		0,
	"PROTO_INET6",		0,
	"PROTO_RIP",		0,
	"PROTO_RIPNG",		0,
	"PROTO_OSPF",		0,
	"PROTO_OSPF2",		0,
	"PROTO_ASPATHS",	0,
	"PROTO_RDISC",		0,
	"PROTO_BGP",		0,
	"PROTO_SNMP",		0,
	"PROTO_DVMRP",		0,
	"PROTO_PIM",		0,
	"PROTO_IGMP",		0,
	"PROTO_GII",		0,
	"AUTONOMOUS_SYSTEM",	0,
	"ROUTER_ID",		0,
	"FLETCHER_CHECKSUM",	0,
	"IP_MULTICAST_ROUTING",	0,
	"SOCK_BUF_PAGES",	1,
	"YYDEBUG",		0,
	"SHADOW_PASSWD",	0,
);

#
# Group of file for different program. For each program we have
# C source files (_src), header files (_hdr), man page (_man), link
# (_link) and object (_obj). This is used when generating Makefile.
#
%fileList = (
	'gated_src',	'',
	'gated_obj',	'',
	'gated_hdr',	'',
	'gdc_src',	'',
	'gdc_obj',	'',
	'gdc_hdr',	'',
	'ripq_src',	'',
	'ripq_obj',	'',
	'ripq_hdr',	'',
	'ospfmon_src',	'',
	'ospfmon_obj',	'',
	'ospfmon_hdr',	'',
	'std_src',	'',
	'std_obj',	'',
	'std_hdr',	'',
	'man_1',	'',
	'man_5',	'',
	'man_8',	'',
	'links',	'',
	'linkdst',	'',
);

#
# Parse the options
#
$Usage = "Usage: $0 [-a] [-f] [-g]
	-a: print the object directory used to build gated.
	-f: filter stcin into stdout.
	-g: Autoconfiguration.
";
while($_ = $ARGV[0], /^-/) {
	shift;
	/^-a/ && do { $optGetObjectDir = 1; $silent = 1; next; };
	/^-f/ && do { $optFilter = 1; $silent = 1; next; };
	/^-g/ && do { $autoConf = 1; next; };
	/^-/  && do { die $Usage; };
}
select STDERR; $| = 1;
select STDOUT; $| = 1;
&saveDefault();

#
# A warning...
#
if ($autoConf) {
	&setLog();	# Log everything to a file

	&Ask("	THIS AUTOCONFIGURATIN SCRIPT HAS BEEN TESTED ON SUNOS4.1.3,	
	SUNOS5.4, BSD/OS2.0 (BSDI), ULTRIX4.4-RISC AND LINUX-2.0.6.
	IF YOUR SYSTEM IS NOT CLOSE TO ONE OF THOSE THE RESULTING 
	CONFIGURATION IS LIKELY TO BE WRONG. 
	ALL INPUT AND OUTPUT IS LOGGED INTO '$logFile'.
	[PRESS <RETURN> TO CONTINUE]", '');
}

#
# figure out where we are. This script should be run on
# <gated>/src, where <gated> is the top directory of the distribution
# package. Let say, if `pwd` ends by 'src', and ./util exist, well,
# that enough to think we are in the correct directory.
#
$cwd = `pwd`; chop $cwd;
@pwd = split(/\//, $cwd);
&myprint("\nCurrent directory \"$cwd\"\n\n") if (!$silent);
if (!$silent && ($pwd[$#pwd] ne 'src' || ! -d 'util')) {
	&myprint("WARNING: this script should be run from the src directory\n",
	     "WARNING: of the distribution package. Continuing anyway...\n\n");
}

#
# Find our architecture...
# 
&arch();

#
# Get the object directory
#
$dirPath{"objdir"} = $obj = &getObjDir();
if ($optGetObjectDir) {
        print (($obj)? $obj: "XXX", "\n");
        exit 0;
};

#
# Get the default configuration file if $autoConf is set
#
&parseConfig($templ) if ($autoConf && ($templ = &findConfig()));

#
# If there is already a Config file, uses it too
#
if ($obj && $autoConf && -e "$obj/Config") {
	$ans = &Ask("\nThere is already a Config file in the object directory.".
		"\nWould you like to use it? [yes] ", 'yes');
	if ($ans =~ /^y/i) {
		&parseConfig("$obj/Config");
	}
}

#
# If there is a local config file, use it!
#
if (-e "./Config") {
	&parseConfig("./Config");
}

#
# If -g is set try to guess everything!
#
if ($autoConf) {
	&autoConfigure;
} else {
	# fixe %unixCmd defaults
	foreach $cmd (keys(%unixCmd)) {
		$unixCmd{$cmd} =~ s/:.*//;
	}
}

#
#  Check if the object directory exist. If autoConf is set, create one.
#
if (!$obj) {
	if (!$autoConf) {
	     &myprint("ERROR: none of the directories \"obj\", \"obj.$arch\",",
		      " or \nERROR: \"obj.$hostname\" exists. Please create",
		      " one with a \nERROR: \"Config\" file in before running",
		      " this script.\n\n");
		exit(1);
	} else {
		&myprint("Creating object directory \"obj.$Architecture\"\n");
		mkdir("obj.$Architecture", 0744) || die(
			"ERROR: cannot create \"obj.$Architecture\": $!\n" .
			"ERROR: Aborting...\n");
		$obj = "obj.$Architecture";
	}
}

#
# Ask for the protocol list to be configured
#
if ($autoConf && !$protocols[0]) {
	$ans = &Ask("\nWhat protocol do you want to use? The choise are:\n\t".
	      join(', ', keys(%proto)) . "\n\t[rip ospf[2] bgp]? ","rip ospf bgp");
	&setProtocol($ans);
}

#
# Create the Config file if $autoConf is set.
#
if ($autoConf) {
	&checkConfig();
	&printConfig("$obj/Config");

	&Ask("\n\tThe auto generated configuration file for your system is
	\"$obj/Config\".
	If you wish to modify any parameter please edit this file and rerun
	'make config' or 'make autoconf'.
	[type <return> to continue]", '');
}

#
# END of AUTOCONFIG section
#
&myprint("\nConfiguring object directory \"$obj\" for hostname \"$hostname\",
	architecture \"$Architecture\"\n\n") if (!$silent);

#
# Parse the Config file
#
&parseConfig("$obj/Config");

#
# If the -f option is used, filter now
#
if ($optFilter) {
	&filterFile('-', '-');
	exit 0;
}

#
# Create the file <obj>/define.h with the list of defines got from
# the options list in the config file + the protocol list
#
&myprint("\nCreating \"$obj/$define_file\"\n");
&printDefines();

#
# Create the <obj>/path.h file. We run paths.h through the filter.
#
&myprint("\nCreating \"$obj/$path_file\" from \"$path_file\"\n");
&filterFile($path_file, "$obj/$path_file");

#
# Create the <obj>/parser.y file. We run parser.ythrough the filter.
#
&myprint("\nCreating \"$obj/$parser_file\" from \"$parser_file\"\n");
&filterFile($parser_file, "$obj/$parser_file");

#
# Parse the 'file' file (file with the list of file to compile.
#
&myprint("\nParsing \"util/$file_file\"\n");
&fileFile("util/$file_file");

#
# Generate the Makefile!
#
&myprint("\nGenerating \"$obj/$Makefile_file\" from " .
	"\"util/$Makefile_file.$template\"\n");
&filterFile("util/$Makefile_file.$template", "$obj/$Makefile_file");

#
# Generate signame.c (sys_signame[]) from signal.h
#
if ($options{"NEED_SIGNAME"}) {
	&myprint("\nGenerating \"$obj/$signame_file\" from <signal.h>\n");
	&signame();
}

#
# Generate version.c (used to hardcode the version number in gated)
#
&myprint("\nCreating \"$obj/$version_file\"\n");
&createVersion();

&myprint("\n");
exit(0);

#
# Get the architecture of the system. Set the $OSname, @OSversion, $OSarch,
# and $Architecture variables.
#
sub arch {
	local($arch, $vers);

	#
	# Try uname(1)
	#
	if ($uname = &findCmd("uname", $unixCmd{"uname"})) {
		$OSname = `uname -s`; chop $OSname; $OSname =~ y/a-z/A-Z/;
		$OSname =~ s/[-_\/\.]+/_/g;
		$vers = `uname -r`; chop $vers;
		@OSversion = split(/\./, $vers);
		$OSarch = `uname -m`; chop $OSarch; $OSarch =~ y/A-Z/a-z/;
		$Architecture = "$OSname-" . join('.', @OSversion) . "-$OSarch";
		return;
	}

	#
	# Well, big trouble...
	#
	&myprint("WARNING: cannot determine the architecture of the system.\n",
	      "WARNING: Without this information the configuration process\n",
	      "WARNING: is likely to FAIL!!!!!\n");
	
	$OSname = ``;
	@OSversion = ();
	$OSarch = '';
	$Architecture = '';
}

#
# Find out with object directory exist. We try obj.`uname`, obj.`hostname` and
# obj.
#
sub getObjDir {
	local($obj) = '';

	$hostname = `hostname`; chop $hostname;

	if ( -d "obj.$Architecture" ) {
        	$obj = "obj.$Architecture";
	} elsif ( -d "obj.$hostname" ) {
        	$obj = "obj.$hostname";
	} elsif ( -d "obj" ) {
        	$obj = "obj";
	} 
	$obj;
}

#
# Parse the configuration file
#
sub parseConfig {
	local($confFile) = $_[0];

	&myprint("Parsing \"$confFile\"\n") if (!$silent);

	if (! -e $confFile) {
           &myprint("ERROR: \"$confFile\" does not exist. Please create one.\n",
	          "ERROR: Aborting...\n");
	    exit(1);
	};
	open(CONFIG, "$confFile") || die(
        	"ERROR: cannot open \"$confFile\": $!\n" .
        	"ERROR: aborting...\n\n");

	$line = 0;
	while(<CONFIG>) {
		chop;
		$line++;

		#
		# Those are comments...
		# ....or blanks lines
		#
		/^\s*#/ && next;
		/^\s*$/ && next;

		#
		# Get the first token
		#
		/^(\w+)\s+(.*)/ && do {
			($token, $value) = ($1, $2);
		};

		#
		# Is it an option?
		#
		if ($token eq 'options') {
			&setOptions($value);
			next;
		}

		#
		# Is it a protocol list?
		#
		if ($token eq 'protocols') {
			&setProtocol($value);
			next;
		}

		#
		# Is it a keywork for an parameter?
		#
		if (defined $unixCmd{$token}) {
			$unixCmd{$token} = $value;
		} elsif (defined $cmdFlags{$token}) {
			$cmdFlags{$token} = $value;
		} elsif (defined $dirPath{$token}) {
			$dirPath{$token} = $value;
		} elsif (defined $miscParam{$token}) {
			$miscParam{$token} = $value;
		} elsif (defined $runtimePath{$token}) {
			$runtimePath{$token} = $value;
		} else {
			#
			# This is an error!
			#
			&myprint("ERROR: syntax error line $line in file".
			       " \"$confFile\": unknown token \"$token\"\n");
			$errparse = 1;
		}
		next;
	}
	close(CONFIG);

	if ($errparse) {
               &myprint("ERROR: There was parsing error(s) in \"$confFile\".\n".
              	      "ERROR: Aborting.\n\n");
        	exit(1);
	}
}

#
# Set the options (actully an #define) list
#
sub setOptions {
	local($val) = @_;
	local($define);
	
	# Get the macro name

	while($val) {
		($val =~ /^([\w\(\),]+)\s+/ || $val =~ /^([\w\(\),]+)\s*$/) && 
			do {
			# This is a simple macro without parameters.
			$options{$1} = 1;
			$val = $';
			next;
		};

		$val =~ /^([\w\(\),]+)=/ && do {
			# This is a macro with parameters.
			# Check if the paramater is in " or ""
			$define = $1;
			$val = $';

			$val =~ /^""(.*)""\s*/ && do {
				# Grabe everything between the two ""
				$options{$define} = "\"$1\"";
				$val = $';
				next;
			};
			$val =~ /^"(.*)"\s*/ && do {
				# Grabe everything between the two "
				$options{$define} = $1;
                                $val = $';
                                next;
                        };
			$val =~ /^([^\s]+)\s*/ && do {
				$options{$define} = $1;
				$val = $';
				next;
			};
			# This is bogus
			&myprint("WARNIN: problem parsing \"$val\"\n");
			last;
		};
		# This is bogus
		&myprint("WARNIN: problem parsing \"$val\"\n");
		last;
	}
}

#
# Set the protocol list
#
sub setProtocol {
	split(/\s+/, $_[0]);
	for($i = 0;  $i <= $#_; $i++) {
		if ($proto{$_[$i]}) {
			undef @def;
			@def = split(/\s+/, $proto{$_[$i]});
			for($j = 0; $j <= $#def; $j++) {
				$options{$def[$j]} = 1;
			}
			push(@protocols, $_[$i]);
		}
	}
}


#
# Print the values of %options and %protocols

sub printDefines {
	open(DEFINE, ">$obj/$define_file") || die(
        	"ERROR: cannot open \"$obj/$define_file\": $!\n" .
        	"ERROR: aborting...\n\n");

	print DEFINE "/* THIS FILE IS CREATED AUTOMATICALLY - DO NOT EDIT */\n";
	print DEFINE "/* File generated from \"$obj/Config\" */\n\n";

	#
	# A define is printed if the value is 1
	#
	foreach $key (sort(keys(%options))) {
		if ($options{$key}) {
			printf(DEFINE "#define %-20s %s\n", $key,
				$options{$key});
		}
	}
	close(DEFINE);
}

#
# Apply a filter to a file. Substitute @(xxx) with the correct value
#
sub filterFile {
	local($from, $to) = @_;

	#
	# Open the source and destination files
	#
	if ($to eq '-') {
		$dst = STDOUT;
	} else {
		open(DST, ">$to") || die(
        		"ERROR: cannot open \"$to\": $!\n" .
        		"ERROR: aborting...\n\n");
		$dst = DST;
	}
	if ($from eq '-') {
		$src = STDIN;
	} else {
		open(SRC, $from) || die(
        		"ERROR: cannot open \"$from\": $!\n" .
        		"ERROR: aborting...\n\n");
		$src = SRC;
	}

	#
	# Run the flter...
	#
	$printLevel = 0;
	$beginLevel = 0;
	while(<$src>) {
		$line = $_;

		#
		# Do conditional compilation of the file
		#
		$line =~ /^\s*\@BEGIN:\s*/ && do {

			$beginLevel++;
			#
			# If we are not printing, just increase the total
			# level of BEGIN
			#
			next if ($printLevel < $beginLevel - 1);

			#
			# See if the symbols after the @BEGIN are defined
			# in %protocols or %options
			#
			undef @symbols;
			@symbols = split(/[\s\n|]+/, $');

			#
			# If the first token is 'NOT' them do the contruary
			#
			if ($symbols[0] eq 'NOT') {
				$nbNot = 0;
				for($i = 1; $i <= $#symbols; $i++) {
					$nbNot++ if (!$options{$symbols[$i]});
				}
				$printLevel++ if ($nbNot == $#symbols);
			} else {
				for($i = 0; $i <= $#symbols; $i++) {
					if ($options{$symbols[$i]}) {
						$printLevel++;
						last;
					}
				}
			}
			next;
		};

		$line =~ /^\s*\@END:/ && do {
			$beginLevel--;
			$printLevel -- if ($printLevel > $beginLevel);
			next;
		};

		#
		#
		#
		next if ($printLevel < $beginLevel);

		#
		# do the substitution.
		#
		$line = &substitute($line);

		print $dst $line;
	}

	close($dst);
	close($src);
}

#
# substitute @() by they value
#
sub substitute {
	local($loop, $str) = (0, $_[0]);

        #
        # do the substitution as long as we can find one to do
        #
        $loop = 0;
        while($str =~ /\@\(([^)]*)\)/) {
                #
                # Safeguard...
                #
                if ($loop++ > 10) {
                        &myprint("ERROR: Too much substitutions!!!\n\n");
                        exit(1);
                }

                #
                # $1 is the thing we try to substitute. Let try
                # to find a match on %dirPath. Also converts $1
                # to lower case (for BINDIR -- go figure why)
                # And remove heading '_'!!!
                #
                $tok = $1;
                $tok =~ y/A-Z/a-z/;
                $tok =~ s/^_//;

                if (defined $dirPath{$tok}) {
                        #
                        # Substitute
                        #
                        $str =~ s/\@\(([^)]*)\)/$dirPath{$tok}/;
                        next;
                } elsif (defined $runtimePath{$tok}) {
                        #
                        # Substitute
                        #
                        $str =~ s/\@\(([^)]*)\)/$runtimePath{$tok}/;
                        next;
                } elsif (defined $miscParam{$tok}) {
                        #
                        # Substitute
                        #
                        $str =~ s/\@\(([^)]*)\)/$miscParam{$tok}/;
                        next;
		} elsif (defined $unixCmd{$tok}) {
                        #
                        # Substitute
                        #
                        $str =~ s/\@\(([^)]*)\)/$unixCmd{$tok}/;
                        next;
                } elsif (defined $cmdFlags{$tok}) {
                        #
                        # Substitute
                        #
                        $str =~ s/\@\(([^)]*)\)/$cmdFlags{$tok}/;
                        next;
		} elsif (defined $fileList{$tok}) {
			#
                        # Substitute
                        #
                        $str =~ s/\@\(([^)]*)\)/$fileList{$tok}/;
                        next;
                }

                #
                # A warning for unknown tokens?
                #
                if ($tok =~ /[a-z]+/) {
                        &myprint("WARNING: token \"@($tok)\" unknown\n");
                }

                #
                # Well, no match, get out!
                #
                last;
        }
	$str;
}

#
# Parse the file with the list of files to compile
#
sub fileFile {
	
	open(FILE, "$_[0]") || die(
		"ERROR: cannot open \"$_[0]: $!\n" .
		"ERROR: aborting...\n\n");

	#
	# Run the same filter as filterFile() except for the @() substitution
	#

        $printLevel = 0;
        $beginLevel = 0;
        while(<FILE>) {
                #
                # Those are comments...
                # ....or blanks lines
                #
                /^\s*#/ && next;
                /^\s*$/ && next;

                $line = $_;

                #
                # Do conditional compilation of the file
                #
                $line =~ /^\s*\@BEGIN:\s*/ && do {

                        $beginLevel++;
                        #
                        # If we are not printing, just increase the total
                        # level of BEGIN
                        #
                        next if ($printLevel < $beginLevel - 1);

                        #
                        # See if the symbols after the @BEGIN are defined
                        # in %protocols or %options
                        #
                        undef @symbols;
                        @symbols = split(/[\s\n|]+/, $');

                        #
                        # If the first token is 'NOT' them do the contruary
                        #
                        if ($symbols[0] eq 'NOT') {
                                $nbNot = 0;
                                for($i = 1; $i <= $#symbols; $i++) {
                                        $nbNot++ if (!$options{$symbols[$i]});
                                }
                                $printLevel++ if ($nbNot == $#symbols);
                        } else {
                                for($i = 0; $i <= $#symbols; $i++) {
                                        if ($options{$symbols[$i]}) {
                                                $printLevel++;
                                                last;
                                        }
                                }
                        }
                        next;
                };

                $line =~ /^\s*\@END:/ && do {
                        $beginLevel--;
                        $printLevel -- if ($printLevel > $beginLevel);
                        next;
                };

                #
                #
                #
                next if ($printLevel < $beginLevel);

		#
		# The first token is the file name, the second (optional)
		# is a prefix for the Makefile variable.
		#
		($sourceFile, $prefix) = split;

		#
		# Make the prefix nicer...
		#
		%prefixList = ("O_", "OSPFMON_", "R_", "RIPQ_", "G_", "GDC_",
			"C_", "STD_");
		$prefix = $prefixList{$prefix};
		$prefix = "GATED_" if (!$prefix);

		#
		# Store by prefix
		#
		$sourceList{$prefix} .= "|$sourceFile";
	}

	close(FILE);

	#
	# Now we have to generate the *_SRC, *_OBJ, *_HDR, *_MAN, *_LINK
	# list for the Makefile.
	#
	foreach $prefix (keys(%sourceList)) {
		&genFileList($prefix);
	}
}

#
# Generate a list of C, object, man and link files for the makefile
#
sub genFileList {
	local($prefix) = $_[0];
	local($obj) = '';

	#
	# Go through the list of file for that prefix
	#
	undef @files;
	@files = split(/\|/, $sourceList{$prefix});
	$prefix =~ y/A-Z/a-z/;

	for($i = 1; $i <= $#files; $i++) {
		$file = $files[$i];

		#
		# Get rid of a heading @(SRCDIR)/
		#
		$file =~ s/^\@\(SRCDIR\)\///;

		#
		# substitute @()
		#
		$file = &substitute($file);

		#
		# The action depend on the sufix of the file...
		#
		$file =~ /\.c$/ && do {		# A C source file
			$fileList{"${prefix}src"} .= " \\\n\t$file";
			if (!&generated($file)) {
				$fileList{"links"} .= " \\\n\t../$file";
				$fileList{"linkdst"} .=
					"\\\n\t" . &basename($file);
			}
			$fileList{"${prefix}obj"} .= &setObject($file, $prefix);
			$VersionFiles .= "|$file";
			next;
		};
		$file =~ /\.o$/ && do {		# An object file
			$file =~ s/.*\///;	# Basename only
			$fileList{"${prefix}obj"} .= &setObject($file, $prefix);
			next;
		};
		$file =~ /\.h$/ && do {
			$fileList{"${prefix}hdr"} .= " \\\n\t$file";
			if (!&generated($file)) {
				$fileList{"links"} .= " \\\n\t../$file";
				$fileList{"linkdst"} .=
					"\\\n\t" . &basename($file);
			}
			$VersionFiles .= "|$file";
			next;
		};
		$file =~ /\.1$/ && do {
			$fileList{"man_1"} .= " \\\n\t$file";
			next;
		};
		$file =~ /\.5$/ && do {
			$fileList{"man_5"} .= " \\\n\t$file";
			next;
		};
		$file =~ /\.8$/ && do {
			$fileList{"man_8"} .= " \\\n\t$file";
			next;
		};
		$file =~ /\.l$/ && do {
			if (!&generated($file)) {
				$fileList{"links"} .= " \\\n\t../$file";
				$fileList{"linkdst"} .=
					"\\\n\t" . &basename($file);
			}
			$fileList{"${prefix}obj"} .= &setObject($file, $prefix);
			next;
		};
		&myprint("WARNING: unknow file type \"$file\"\n");
	}
}

#
# Return 1 if the file is one of the one we have to generate, i.e. is
# in the @generatedList[] array. (for those file no link should be created)
#
sub generated {
	local($fname) = $_[0];

	$fname =~ s/.*\///;	# get rid of the path
	foreach $f (@generatedList) {
		$f =~ s/.*\///;
		return(1) if ($f eq $fname);
	}
	0;
}

#
# return the name of the object file to be concated to *_OBJ
#
sub setObject {
	local($obj, $prefix) = @_;

	# Remove any leading path..
	$obj =~ s/.*\///;

	# Change .l or .c or .* to .o
	$obj =~ s/\..$/.o/;

	# If the file already in the fileList{} ?
	if ($fileList{"${prefix}obj"} =~ /\n\t$obj/) {
		return '';
	} else {
		return " \\\n\t$obj";
	}
}

#
# Will generate signame.c from signal.h
#
sub signame {
	#
	# Try to fing out where is the <signal.h> file.
	# If $dirPath{"signal_h"} is defined them use this one,
	# else try a few well known files: <sys/signal.h> and <signal.h>
	#
	$sigfile = '';
	if ($dirPath{"signal_h"}) {
		$sigfile = $dirPath{"signal_h"};
	} else {
		if (!($sigfile = &findInclude('sys/signal.h'))) {
			$sigfile = &findInclude('signal.h');
		}
	}

	if (!$sigfile) {
	    &myprint("ERROR: cannot locate the <signal.h> include file in \n",
		     "ERROR: ", join(', ', @includeDir), "\n",
		     "ERROR: aborting\n\n");
	    exit(1);
	}

	open(SIGIN, $sigfile) || die(
		"ERROR: cannot open \"$sigfile\": $!\n" .
		"ERROR: aborting...\n\n");
	open(SIGOUT, ">$obj/$signame_file") || die(
		"ERROR: cannot open \"$obj/$signame_file\": $!\n" .
		"ERROR: aborting...\n\n");

	print SIGOUT
		"/* This file is automatically generated from $sigfile */\n",
		"\n#define INCLUDE_SIGNAL\n#include \"include.h\"\n\n",
		"const char *const sys_signame[] = {\n";;

	#
	# Filter the signal.h file for line like '#define SIGUSR1 30',
	# and create an entry in sys_signame[]
	#
	while(<SIGIN>) {
		/^\s*#define\s+(SIG[A-Z1-9]+)\s+(\d+)[^\w]/ && do {
			$signal[$2] = $1;
			next;
		};
	}

	#
	# Safeguard...
	#
	if ($#signal == -1) {
		&myprint("WARNING: no signals found in $sigfile\n",
			 "WARNING: correct signal_h in config file.\n");
	}
	if ($#signal >= 64) {
		&myprint("WARNING: more than 63 signals defined ($#signal)\n",
			 "WARNING: Only 64 will be used.\n");
		$#signal = 63;
	}
    
	for($i = 0; $i <= $#signal; $i++) {
		if ($signal[$i]) {
			print SIGOUT "\t\"$signal[$i]\",\t/* $i */\n";
		} else {
			print SIGOUT "\t\"Signal $i\",\t/* $i */\n";
		}
	}
	print SIGOUT "};\n";
	close(SIGOUT);
}


#
# Create a file with information about the version
#
sub createVersion {

	#
	# First the Gated version, built date, and 'version_id' (?)
	# The version is in a file called VERSION in the source directory.
	#
	open(VERSION, "$source_version") || die(
		"ERROR: cannot open \"$source_version\": $!\n" .
		"ERROR: aborting...\n\n");
	$version = <VERSION>; chop $version;
	close(VERSION);

	#
	# Get the time...
	#
	$date = `date`; chop $date;

        open(VERSION, ">$obj/$version_file") || die(
                "ERROR: cannot open \"$obj/$version_file\": $!\n" .
                "ERROR: aborting...\n\n");

	print VERSION "#include \"include.h\"\n\n";
	print VERSION "const char *gated_version = \"$version\";\n";
	print VERSION "const char *build_date = \"$date\";\n";
	print VERSION "const char *version_id = \"\@(#)gated $version $date\";\n";
	 print VERSION "\n";

	#
	# Now the rest of this file is the version number of all the sources
	# and header of gated. Those are in %sourceList{"gated_"}.
	# $VersionFiles was defined in genFileList().
	#
        undef @files;
        @files = split(/\|/, $VersionFiles);
	shift @files;	# The first name is empty!

	foreach $fname (@files) {

		open(SRC, "$fname") || do {
			#
			# Try to see if the file is in the object directory
			#
			open(SRC, "$obj/$fname") || do {
			      &myprint("WARNING: cannot open \"$fname\": $!\n");
			      next;
			};
		};
		while(<SRC>) {
			/\@\(#\)[^\s]+\s+([^"]*)/ && do {
				$ver = $1; #chop $ver;
				# Remove any wierd stuf...
				$var = $fname; $var =~ s/[^\w]/_/g;
				$ver =~ s/[\n\r]/ /g;
				print VERSION
				"const char *$var = \"$fname $ver \";\n";
				last;
			};
		}
		close(SRC);
	}
}

#
# Autoconfiguration process
#
sub autoConfigure {
	#
	# first the Unix commands.
	#
	&myprint("\nLooking for Unix commands in ", join(' ', @path), " and ",
		join(' ', @extraPath), "\n");
	foreach $item (keys(%unixCmd)) {
		$unixCmd{$item} = &findCmd($item, $unixCmd{$item});
	}

	#
	# Find out about the flags to use
	#
	&myprint("\nLooking for Unix commands flags\n");
	foreach $flag (keys(%cmdFlags)) {
		$cmdFlags{$flag} = &findFlags($flag, $cmdFlags{$flag});
	}

	#
	# Find out about the default directories (%dirPath)...
	# and %miscParam, %runtimePath
	#
	&myprint("\nLooking for directories, files and other stuff...\n");
	foreach $val (keys(%dirPath)) {
		$dirPath{$val} = &findfiles($val, $dirPath{$val});
	}
	foreach $val (keys(%miscParam)) {
		$miscParam{$val} = &findfiles($val, $miscParam{$val});
	}
	foreach $val (keys(%runtimePath)) {
		$runtimePath{$val} = &findfiles($val, $runtimePath{$val});
	}

	#
	# Initialise the Symbol list
	#
	&getKernSymbol('', '');
	&getSymbol('', '');

	#
	#  Now all the options!
	#
	foreach $val (keys(%options)) {
		$options{$val} = &getOptions($val, $options{$val});
	}
}

#
# find a Unix command
#
sub findCmd {
	local($cmd, $default) = @_;

	#
	# We may have several names separated by ':'
	#
	@defNames = split(/:/, $default);
	foreach $defName (@defNames) {
		#
		# If the name is a full path, try it
		#
		if ($defName =~ /^\//) {
			if (-e $defName) {
				&myprint("Command \"$cmd\" is \"$defName\"\n");
				return $defName;
			}
		}
		#
		#  Look through the path and the extra path
		#
		foreach $dir (@path) {
			if (-e "$dir/$defName") {
			     &myprint("Command \"$cmd\" is \"$dir/$defName\"\n")
					unless($silent);
			     return $defName;
			}
		}
		foreach $dir (@extraPath) {
			if (-e "$dir/$defName") {
			     &myprint("Command \"$cmd\" is \"$dir/$defName\"\n")
					unless($silent);
			     return "$dir/$defName";
			}
		}
	}
	&myprint("WARNING: Command \"$cmd\" not found. Using \"",
		$defNames[0], "\"\n") unless($silent);
	$defNames[0];
}

#
# Looking for command flags. A big guess!!!!!!
#
sub findFlags {
	local($flag, $default) = @_;

	$val = $default;

	case: {
	($flag eq "cflags") && do { last case; };
	($flag eq "installflags") && do { last case; };
	($flag eq "ldflags") && do { last case; };
	($flag eq "lflags") && do {
		# -v for lex, -p -s -c for flex!
		$val = '-p -s -C' if ($unixCmd{"lex"} =~ /flex$/);
		last case; };
	($flag eq "lintflags") && do { last case; };
	($flag eq "yflags") && do {
		$val = '-d -y -v' if ($unixCmd{"yacc"} =~ /bison$/);
		last case; };
	($flag eq "tflags") && do { last case; };
	($flag eq "cwflags") && do { last case; };
	($flag eq "ldothers") && do { last case; };
	($flag eq "lnflags") && do { last case; };
	}

	&myprint("$flag is \"$val\"\n");
	$val;
}

#
# Look for file, directories...
#
sub findfiles {
	local($name, $default) = @_;
	local($val) = $default;

        case: {
	($name eq "path_unix") && do {
		# If default there, use it
		if ($val && -e $val) {
			&myprint("Parameter \"$name\" is \"$val\"\n");
			return $val;
		}
		# Well, just a few common names
		foreach $val (@path_unix) {
			if ($val && -e $val) {
				&myprint("Parameter \"$name\" is \"$val\"\n");
				return $val;
			}
		}
		&myprint("Parameter \"$name\" no found in ", join(' ',
			@path_unix), ". Using default \"$default\"\n");
		return $default;
	};
	($name eq "signal_h") && do {
		# If default there, use it
                if ($val && -e $val) {
                        &myprint("The include file <signal.h> is \"$val\"\n");
                        return $val;
                }
                # Well, just a few common names
		if (!($val = &findInclude('sys/signal.h'))) {
			$val = &findInclude('signal.h');
		}
		if ($val) {
			&myprint("The include file <signal.h> is \"$val\"\n");
			return $val;
		}
		&myprint("The include file <signal.h> \"$name\" no found in ",
			join(' ', @includeDir),
			". Using default \"$default\"\n");
		return $default;
	};
	}
	&myprint("Parameter \"$name\" is \"$val\"\n");
	return $default;
}

#
# Guess all the options!
#
sub getOptions {
	local($name, $default) = @_;
	local($val) = '';

	case: {
        ($name eq "ENVIRON") && do {
		$val = &getSymbol("environ:_environ", ".");
		last case;
	};
        ($name eq "IBM_6611") && do {
		last case;
	};
	($name eq "SUNOS5_0") && do {
		$val = 1 if ($OSname eq "SUNOS" && $OSversion[0] == 5);
		last case;
	};
	# Well, hard to guess
        ($name eq "KRT_IFR_MTU") && do { last case; };
        ($name eq "ISODE_SNMP_NODEFS") && do { last case; };

        ($name eq "NEED_HERRNO") && do {
		$val = (&getSymbol("h_errno", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_HERRS") && do {
		$val = (&getSymbol("h_nerr", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_FFS") && do {
		$val = (&getSymbol("ffs", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_SYSCONF") && do {
		$val = (&getSymbol("sysconf", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_UNSETENV") && do {
		$val = (&getSymbol("unsetenv", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_STRCASECMP") && do {
		$val = (&getSymbol("strcasecmp", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_STRERROR") && do {
		$val = (&getSymbol("strerror", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_INET_ATON") && do {
		$val = (&getSymbol("inet_aton", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_SIGNAME") && do {
		$val = (&getSymbol("sys_signame", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_SETVBUF") && do {
		$val = (&getSymbol("setvbuf", "."))? 0: 1;
		last case;
	};
        ($name eq "NEED_FLOCK") && do {
		$val = (&getSymbol("flock", ".") &&
                        &getDefine('LOCK_EX', 'sys/file.h:fcntl.h'))? 0: 1;
		last case;
	};
        ($name eq "MIB_GATED") && do {
		$val = 0;
		last case;
	};
        ($name eq "MIB_RIP") && do {
		$val = 0;
		last case;
	};
	#
	# Choose only one of the 5 following
	#
	(($name eq "KRT_RTREAD_KMEM") ||
	($name eq "KRT_RTREAD_KINFO") ||
	($name eq "KRT_RTREAD_PROC") ||
	($name eq "KRT_RTREAD_RADIX") ||
	($name eq "KRT_RTREAD_SUNOS5")) && do {
		#
		# Only one is set
		#
		$count = $options{"KRT_RTREAD_KMEM"} +
			 $options{"KRT_RTREAD_KINFO"} +
			 $options{"KRT_RTREAD_RADIX"} +
			 $options{"KRT_RTREAD_SUNOS5"};
		if ($count == 1) {
			$val = $options{$name};
			last case;
		}
		if ($count) {
			&myprint("ERROR: KRT_RTREAD_* set more than once\n",
				 "ERROR: aborting...\n");
			exit(1);
		}

		# Sun OS 5 is easy...

		if ($OSname eq 'SUNOS' && $OSversion[0] == 5) {
			$options{"KRT_RTREAD_SUNOS5"} = 1;
			$val = $options{$name};
			last case;
		}

		# _PROC if /proc/version exists.

                if (-e '/proc/version') {
                        $options{"KRT_RTREAD_PROC"} = 1;
                        $val = $options{$name};
                        last case;
                }

		# _KINFO uses getkerninfo() or sysctl()

		if (&getSymbol("getkerninfo", ".")||&getSymbol("sysctl", ".")) {
			$options{"KRT_RTREAD_KINFO"} = 1;
			$val = $options{$name};
                        last case;
                }

		# _KMEM reads _rthost, _rtnet, _rthashsize

		if (&getKernSymbol('_rthost', '.') &&
				&getKernSymbol('_rtnet','.') &&
				&getKernSymbol('_rthashsize','.')) {
			$options{"KRT_RTREAD_KMEM"} = 1;
			$val = $options{$name};
			last case;
		}

		# _RADIX reads _radix_node_head

		if (&getKernSymbol('_radix_node_head', '.')) {
			$options{"KRT_RTREAD_RADIX"} = 1;
			$val = $options{$name};
                        last case;
                }

		# An error!
		&myprint("ERROR: cannot find KRT_RTREAD_*\n");
		&myprint("ERROR: aborting...\n");
		exit(1);
	};

	#
        # Choose only one of the 2 following
        #
        (($name eq "KRT_IFREAD_IOCTL") ||
	($name eq "KRT_IFREAD_KINFO")) && do {
		$count = $options{"KRT_IFREAD_IOCTL"} +
			 $options{"KRT_IFREAD_KINFO"};
		if ($count == 1) {
			$val = $options{$name};
			last case;
		}
		if ($count) {
                        &myprint("ERROR: KRT_IFREAD_* set more than once\n");
                        &myprint("ERROR: aborting...\n");
                        exit(1);
                }

		# _KINFO when getkerninfo() or sysctl() exist.

		if (&getSymbol("getkerninfo", ".")||&getSymbol("sysctl", ".")) {
                        $options{"KRT_IFREAD_KINFO"} = 1;
                        $val = $options{$name};
                        last case;
                }

		# _IOCTL when SIOCGIFCONF is defined

		if (&getDefine('SIOCGIFCONF', 'if.h')) {
			$options{"KRT_IFREAD_IOCTL"} = 1;
			$val = $options{$name};
			last case;
                }

		# An error!
                &myprint("ERROR: cannot find KRT_IFREAD_*\n");
                &myprint("ERROR: aborting...\n");
                exit(1);
        };

        (($name eq "KRT_RT_SOCK") ||
	($name eq "KRT_RT_IOCTL")) && do {
		$count = $options{"KRT_RT_SOCK"} +
			 $options{"KRT_RT_IOCTL"};
		if ($count == 1) {
			$val = $options{$name};
			last case;
		}
		if ($count) {
			&myprint("ERROR: KRT_RT_* set more than once\n");
                        &myprint("ERROR: aborting...\n");
                        exit(1);
                }

                # _SOCK when the routing socket exists.

                if (&getDefine('PF_ROUTE', 'socket.h')) {
                        $options{"KRT_RT_SOCK"} = 1;
                        $val = $options{$name};
                        last case;
                }

                # _IOCTL when SIOCADDRT and SIOCDELRT exist

                if (&getDefine('SIOCADDRT', 'sockio.h') &&
				&getDefine('SIOCDELRT', 'sockio.h')) {
                        $options{"KRT_RT_IOCTL"} = 1;
                        $val = $options{$name};
                        last case;
                }

                # An error!
                &myprint("ERROR: cannot find KRT_IFREAD_*\n");
                &myprint("ERROR: aborting...\n");
                exit(1);
        };

	($name eq "KRT_RT_NOCHANGE") && do { last case; };

        (($name eq "KRT_LLADDR_KMEM") ||
	($name eq "KRT_LLADDR_LINUX") ||
	($name eq "KRT_LLADDR_SUNOS4") ||
	($name eq "KRT_LLADDR_SUNOS5") ||
	($name eq "KRT_LLADDR_NONE")) && do {
		$count = $options{"KRT_LLADDR_KMEM"} +
                         $options{"KRT_LLADDR_LINUX"} +
                         $options{"KRT_LLADDR_SUNOS4"} +
                         $options{"KRT_LLADDR_SUNOS5"} +
                         $options{"KRT_LLADDR_NONE"};
                if ($count == 1) {
                        $val = $options{$name};
                        last case;
                }
                if ($count) {
                        &myprint("ERROR: KRT_LLADDR_* set more than once\n");
                        &myprint("ERROR: aborting...\n");
                        exit(1);
                }

		# SUN OS 4 or 5 are easy...

		if ($OSname eq 'SUNOS' && $OSversion[0] == 5) {
                        $options{"KRT_LLADDR_SUNOS5"} = 1;
                        $val = $options{$name};
                        last case;
                }
		if ($OSname eq 'SUNOS' && $OSversion[0] == 4) {
                        $options{"KRT_LLADDR_SUNOS4"} = 1;
                        $val = $options{$name};
                        last case;
                }

		# Well _LINUX suppose that SIOCGIFHWADDR exist...

		if (&getDefine('SIOCGIFHWADDR', 'sockio.h')) {
			$options{"KRT_LLADDR_LINUX"} = 1;
			$val = $options{$name};
			last case;
		}

		# _KMEM ???

		# NONE by default?

		$options{"KRT_LLADDR_NONE"} = 1;
		last case;
	};

        (($name eq "KRT_SYMBOLS_NLIST") ||
	($name eq "KRT_SYMBOLS_PROC") ||
	($name eq "KRT_SYMBOLS_SUNOS5") ||
	($name eq "KRT_SYMBOLS_SYSCTL")) && do {
                $count = $options{"KRT_SYMBOLS_NLIST"} +
                         $options{"KRT_SYMBOLS_SUNOS5"} +
                         $options{"KRT_SYMBOLS_PROC"} +
                         $options{"KRT_SYMBOLS_SYSCTL"};
                if ($count == 1) {
                        $val = $options{$name};
                        last case;
                }
                if ($count) {
                        &myprint("ERROR: KRT_SYMBOLS_* set more than once\n");
                        &myprint("ERROR: aborting...\n");
                        exit(1);
                }

                # SUN OS 5 is easy...

                if ($OSname eq 'SUNOS' && $OSversion[0] == 5) {
                        $options{"KRT_SYMBOLS_SUNOS5"} = 1;
                        $val = $options{$name};
                        last case;
                }

                # _SYSCTL when sysctl() exists.

                if (&getSymbol("sysctl", ".")) {
                        $options{"KRT_SYMBOLS_SYSCTL"} = 1;
                        $val = $options{$name};
                        last case;
                }

		# _NLIST if nlist() exists.

		if (&getSymbol('nlist', '.')) {
			$options{"KRT_SYMBOLS_NLIST"} = 1;
			$val = $options{$name};
                        last case;
                }

		# If /proc/version exist, this is _PROC!

		if (-e '/proc/version') {
			$options{"KRT_SYMBOLS_PROC"} = 1;
                        $val = $options{$name};
                        last case;
                }

		# An error!
                &myprint("ERROR: cannot find KRT_SYMBOLS_*\n");
                &myprint("ERROR: aborting...\n");
                exit(1);
        };

        ($name eq "KRT_NETOPTS") && do {
		$val = (&getDefine('SIOCGNETOPT', 'sockio.h'))? 1: 0;
		last case;
	};

        ($name eq "KRT_SOCKET_TYPE") && do {
		# If the routing socket are there, uses...
		if (&getDefine('PF_ROUTE', 'socket.h')) {
			$val = 'PF_ROUTE, SOCK_RAW, AF_UNSPEC';
			last case;
		}
		last case;
	};
        (($name eq "KVM_TYPE_SUNOS4") ||
        ($name eq "KVM_TYPE_BSD44") ||
        ($name eq "KVM_TYPE_RENO") ||
        ($name eq "KVM_TYPE_OTHER") ||
        ($name eq "KVM_TYPE_NONE")) && do {
		$count = $options{"KVM_TYPE_SUNOS4"} +
                         $options{"KVM_TYPE_BSD44"} +
                         $options{"KVM_TYPE_RENO"} +
                         $options{"KVM_TYPE_OTHER"} +
                         $options{"KVM_TYPE_NONE"};
		if ($count == 1) {
                        $val = $options{$name};
                        last case;
                }
                if ($count) {
                        &myprint("ERROR: KVM_TYPE_* set more than once\n");
                        &myprint("ERROR: aborting...\n");
                        exit(1);
                }

		# SunOS 4 is easy...

		if ($OSname eq 'SUNOS' && $OSversion[0] == 4) {
                        $options{"KVM_TYPE_SUNOS4"} = 1;
                        $val = $options{$name};
                        last case;
                }

		# KVM_TYPE_RENO ??? Well, a pain...
		# If kvm_nlist() is not here, uses KVM_TYPE_OTHER.

		if (&getSymbol('kvm_openfiles', '.')) {
			if (&getSymbol('kvm_nlist', '.')) {
				$options{"KVM_TYPE_BSD44"} = 1;
			} else {
				$options{"KVM_TYPE_OTHER"} = 1;
			}
			$val = $options{$name};
			last case;
		}

		# Type none by default?

		$options{"KVM_TYPE_NONE"} = 1;
		last case;
	};

	#
	# No known method for guessing!
	#
        ($name eq "SIGTYPE") && do {
		last case;
	};
	# The same...
        ($name eq "SIGRETURN") && do {
		last case;
	};
	# Hard to guess...
        ($name eq "VOID_T") && do { last case; };

	# No known method for guessing!
        ($name eq "GID_T") && do { last case; };

	# No known method for guessing!
	($name eq "PID_T") && do { last case; };

	#
	# Choose only one for the multicast kernel
	#
	(($name eq "KRT_IPMULTI_TTL0") ||
	($name eq "KRT_IPMULTI_RTSOCK") ||
	($name eq "KRT_IPMULTI_NOCACHE")) && do {
		#
                # Only one is set
                #
                $count = $options{"KRT_IPMULTI_TTL0"} +
                         $options{"KRT_IPMULTI_RTSOCK"} +
			 $options{"KRT_IPMULTI_NOCACHE"};
		if ($count == 1 || $MultiIP) {
			$val = $options{$name};
			last case;
		}
		if ($count) {
			&myprint("ERROR: KRT_IPMULTI_* set more than once\n",
                                 "ERROR: aborting...\n");
                        exit(1);
                }
		$MultiIP =
		&Ask("\n\tDo you want to install any multicast kernel support?".
		"\n\tIt is mandatory if you want to use RIP-2 or DVMRP/PIM.".
		"\n\tThe possible choise currenlty are:".
		"\n\t\t'none' for no support".
		"\n\t\t'ttl0' for the Xerox PARC IP Multicast 3.3 and 3.5".
		"\n\t\t\tkernel releases (mrouted for SunOS)".
		"\n\tYour choice? ", 'none');

		# Nothing to do!

		if ($MultiIP =~ /none/) {
			last case;
		};

		# Xerox PARC IP Multicast 3.3
	
		if ($MultiIP =~ /ttl0/) {
			$options{"KRT_IPMULTI_TTL0"} = 1;
			last case;
		};

		# some weirdo!

		&myprint("Unknown answer. No IP multicast configured.\n");
		$MultiIP = 'none';
		last case;
	};
        ($name eq "KSYM_IPFORWARDING") && do {
		$val = &getKernSymbol("_ip_forwarding:_ipforwarding", '.');
		$val = ($val)? "\"$val\"": $default;
		last case;
	};
        ($name eq "KSYM_UDPCKSUM") && do {
		$val = &getKernSymbol("_udpcksum:_udp_cksum", '.');
		$val = ($val)? "\"$val\"": $default;
		last case;
	};
        ($name eq "KSYM_RADIXHEAD") && do {
		$val = &getKernSymbol("_radix_node_head", '.');
		$val = ($val)? "\"$val\"": $default;
		last case;
	};
        ($name eq "KSYM_RTHASHSIZE") && do {
		$val = &getKernSymbol("_rthashsize", '.');
		$val = ($val)? "\"$val\"": $default;
		last case;
	};
        ($name eq "KSYM_IFNET") && do {
		$val = &getKernSymbol("_ifnet", '.');
		$val = ($val)? "\"$val\"": $default;
		last case;
	};
        ($name eq "KSYM_RTHOST") && do {
		$val = &getKernSymbol("_rthost", '.');
		$val = ($val)? "\"$val\"": $default;
		last case;
	};
        ($name eq "KSYM_RTNET") && do {
		$val = &getKernSymbol("_rtnet", '.');
		$val = ($val)? "\"$val\"": $default;
		last case;
	};
        ($name eq "KSYM_VERSION") && do {
		$val = &getKernSymbol("_version", '.');
		$val = ($val)? "\"$val\"": $default;
		last case;
	};

	# Hum... The default should be OK almost everywhere :)

        ($name eq "U_INT8") && do {
		last case;
	};
        ($name eq "S_INT8") && do {
		last case;
	};
        ($name eq "U_INT16") && do {
		last case;
	};
        ($name eq "S_INT16") && do {
		last case;
	};
        ($name eq "U_INT32") && do {
		last case;
	};
        ($name eq "S_INT32") && do {
		last case;
	};
        ($name eq "U_INT64") && do {
		last case;
	};
        ($name eq "S_INT64") && do {
		last case;
	};

	# Hum, seems to be 1 all time?
        ($name eq "__GATED__") && do {
		last case;
	};
	# Default is fine.
        ($name eq "GDC_RESOURCE") && do {
		last case;
	};
	# Default is fine.
        ($name eq "LOG_OPTIONS") && do {
		last case;
	};
	# Default is fine.
        ($name eq "LOG_FACILITY") && do {
		last case;
	};
	# Default is fine.
        ($name eq "LOCAL_VERSION") && do {
		last case;
	};
	# Default is fine.
        ($name eq "IFL_NAMELEN") && do {
		last case;
	};
	# No way to guess. Default is fine!
        ($name eq "NLIST_T") && do {
		last case;
	};
	# No way to guess. Default is fine!
        ($name eq "NLIST(fd,nl,sz)") && do {
		last case;
	};
	# No way to guess. Default is fine!
        ($name eq "GA2S(x)") && do {
		last case;
	};
	# No way to guess. Default is fine!
        ($name eq "GS2A(x)") && do {
		last case;
	};
	# No way to guess. Default is fine!
        ($name eq "RT_N_MULTIPATH") && do {
		last case;
	};
        ($name eq "INET_CLASS_E") && do {
		last case;
	};
        ($name eq "MIB_GATED") && do {
		last case;
	};
        ($name eq "HPUX_7") && do {
		$val = 1 if ($OSname eq "HPUX" && $OSversion[0] == 7);
		last case;
	};
        ($name eq "SUNOS_5") && do {
		$val = 1 if ($OSname eq "SUNOS" && $OSversion[0] == 5); 
                last case;                
        };
	# No way to guess. Default is fine!
        ($name eq "SYSV") && do {
		last case;
	};
	# No way to guess. Default is fine!
        ($name eq "SYSVR4") && do {
		last case;
        };
	($name eq "_SC_PAGE_SIZE") && do {
		$val = '_SC_PAGESIZE' if (!&getSymbol('getpagesize', '.'));
		last case;
	};
	# No way to guess. Default is fine!
        ($name eq "ROUTES_WO_MBUFS") && do {
		last case;
        };
	# No way to guess. Default is fine!
        ($name eq "P2P_RT_REMOTE") && do { last case; };
	# No way to guess. Default is fine!
        ($name eq "VARIABLE_MASKS") && do { last case; };
	# No way to guess. Default is fine!
        ($name eq "SOCKET_LENGTHS") && do { last case; };
        ($name eq "SOCKADDR_DL") && do {
		$val = 1 if (&getDefine('AF_LINK', "socket.h"));
		last case;
	};
        ($name eq "INCLUDE_IF_DL") && do {
		$val = (&findInclude('if_dl.h'))? 1: 0;
		last case;
	};
	# No way to guess. Default is fine!
        (($name eq "BSD_SIGNALS") ||
	($name eq "SYSV_SIGNALS") ||
	($name eq "POSIX_SIGNALS")) && do {
		$count = $options{"BSD_SIGNALS"} +
			 $options{"SYSV_SIGNALS"} +
			 $options{"POSIX_SIGNALS"};
		if ($count == 1) {
                        $val = $options{$name};
                        last case;
                }
                if ($count) {
                        &myprint("ERROR: *_SIGNAL set more than once\n");
                        &myprint("ERROR: aborting...\n");
                        exit(1);
                }

		# POSIX_ if sigaction() exists

		if (&getSymbol("sigaction", ".")) {
			$options{"POSIX_SIGNALS"} = 1;
                        $val = $options{$name};
                        last case;
                }

		# If sigset exists it's SYSV_SIGNALS

		if (&getSymbol("sigset", ".")) {
                        $options{"SYSV_SIGNALS"} = 1;
                        $val = $options{$name};
                        last case;
                }

		# Default to BSD?

		$options{"BSD_SIGNALS"} = 1;
		$val = $options{$name};
		last case;
	};
		
        ($name eq "HAVE_WAITPID") && do {
		$val = (&getSymbol("waitpid", "."))? 1: 0;
		last case;
	};
        ($name eq "NO_STAT") && do {
		$val = (&getSymbol("stat", "."))? 0: 1;
		last case;
	};

	# No way to guess
        ($name eq "NO_FORK") && do { last case; };
	# No way to guess
        ($name eq "NO_IP_MULTICAST") && do { last case; };

        ($name eq "HAVE_GETSYSTIMES") && do {
		$val = (&getSymbol("getsystems", "."))? 1: 0;
                last case;
        };
        ($name eq "INCLUDE_UNISTD") && do {
		$val = (&findInclude('unistd.h'))? 1: 0;
                last case;
        };
        ($name eq "INCLUDE_STRING") && do {
		$val = (&findInclude('strings.h'))? 0: 1;
                last case;
        };
        ($name eq "NO_MBUF_H") && do {
		$val = (&findInclude('mbuf.h'))? 0: 1;
		last case;
        };
        ($name eq "NO_STDDEF_H") && do {
		$val = (&findInclude('stddef.h'))? 0: 1;
                last case;
        };
	# No way to guess
        ($name eq "NO_INCLUDE_TIME") && do { last case; };
	# No way to guess
        ($name eq "INCLUDE_FCNTL") && do { last case; };
	# No way to guess
        ($name eq "INCLUDE_TYPES") && do { last case; };
	# No way to guess
        ($name eq "INCLUDE_BSDTYPES") && do { last case; };
	# No way to guess
        ($name eq "USE_STREAMIO") && do { last case; };
	# No way to guess
        ($name eq "INCLUDE_STREAMIO") && do { last case; };

        ($name eq "USE_SYSCTL") && do {
		$val = (&getSymbol("sysctl", '.'))? 1: 0;
		last case;
        };
	# No way to guess
        ($name eq "INCLUDE_SOCKIO") && do { last case; };
	# No way to guess
        ($name eq "INCLUDE_SIOCTL") && do { last case; };
	# No way to guess
        ($name eq "ICMP_NOIP_HEADER") && do { last case; };
	# No way to guess
        ($name eq "LINGER_NO_PARAM") && do { last case; };

        ($name eq "INCLUDE_PATHS") && do {
		$val = (&findInclude('paths.h'))? 1: 0;
                last case;
        };
	# No way to guess????????
        ($name eq "NLIST_NOUNDER") && do { last case; };
	# No way to guess
        ($name eq "USE_SETPGRP") && do { last case; };
	# Well, later...
        ($name eq "SYS_SIGNAME") && do { last case; };
	# No way to guess
        ($name eq "MUST_FFLUSH") && do { last case; };
	# No way to guess
        ($name eq "FLAT_FS") && do { last case; };
	# No way to guess
        ($name eq "UNDEF_RCVBUF") && do { last case; };
        ($name eq "HAVE_DIRENT") && do {
		$val = (&findInclude('dirent.h'))? 1: 0;
                last case;
        };
	# Well, later...
        ($name eq "BYTE_ORDER") && do { last case; };
	# Default is fine. No way to guess
        ($name eq "RTBIT_SIZE") && do { last case; };
        ($name eq 'bcmp(b1,b2,l)') && do {
		$val = "memcmp(b1, b2, (size_t) l)"
			if (!&getSymbol("bcmp", '.'));
		last case;
        };
        ($name eq "bcopy(s,d,l)") && do {
		$val = "memcpy(d, s, (size_t) l)"
			if (!&getSymbol("bcopy", '.'));
		last case;
        };
        ($name eq "bzero(s,l)") && do {
		$val = "memset(s, 0, (size_t) l)"
			if (!&getSymbol("bzero", '.'));
                last case;
        };
        ($name eq "getpagesize()") && do {
		$val = "BUFSIZE" if (!&getSymbol("getpagesize", '.'));
		last case;
	};
        ($name eq "getwd(path)") && do {
		$val = "getcwd(path, sizeof(path))"
			if (!&getSymbol("getwd", '.'));
                last case;
        };
        ($name eq "index") && do {
		$val = "strchr" if (!&getSymbol("index", '.'));
		last case;
	};
        ($name eq "rindex") && do {
		$val = "strrchr" if (!&getSymbol("rindex", '.'));
		last case;
	};
        ($name eq "sigmask(m)") && do {
		$val = "(1 << ((m)-1))" if (!&getSymbol("sigmask", '.'));
		last case;
        };
	# Huh, what to do?
        ($name eq "tzset()") && do { last case; };
        ($name eq "tzsetwall()") && do {
		$val = '{unsetenv("TZ");tzset();}'
			if (!&getSymbol("tzsetwall", '.'));
		last case;
	};
        ($name eq "ftruncate(f,o)") && do {
		$val = "truncate(path_pid,o)"
			if (!&getSymbol("ftruncate", '.'));
		last case;
	};
	# Use default for the following. Automactly set.
        ($name eq "MD5_CHECKSUM") && do { last case; };
        ($name eq "PROTO_HELLO") && do { last case; };
        ($name eq "PROTO_ICMP") && do { last case; };
        ($name eq "PROTO_INET") && do { last case; };
        ($name eq "PROTO_INET6") && do { last case; };
        ($name eq "PROTO_RIP") && do { last case; };
        ($name eq "PROTO_RIPNG") && do { last case; };
        ($name eq "PROTO_OSPF") && do { last case; };
        ($name eq "PROTO_OSPF2") && do { last case; };
        ($name eq "PROTO_ASPATHS") && do { last case; };
        ($name eq "PROTO_RDISC") && do { last case; };
        ($name eq "PROTO_BGP") && do { last case; };
        ($name eq "PROTO_EGP") && do { last case; };
        ($name eq "PROTO_SNMP") && do { last case; };
        ($name eq "PROTO_DVMRP") && do { last case; };
        ($name eq "PROTO_PIM") && do { last case; };
        ($name eq "PROTO_IGMP") && do { last case; };
        ($name eq "PROTO_GII") && do { last case; };
        ($name eq "AUTONOMOUS_SYSTEM") && do { last case; };
        ($name eq "ROUTER_ID") && do { last case; };
        ($name eq "FLETCHER_CHECKSUM") && do { last case; };
        ($name eq "IP_MULTICAST_ROUTING") && do { last case; };
	($name eq "YYDEBUG") && do { last case; };
	($name eq "SHADOW_PASSWD") && do { last case; };

	($name eq "SOCK_BUF_PAGES") && do {
		# Just ask the guy if he gonna install a lot of
		# interface? NOT YET.
		last case;
	};

	&myprint("BUG: Unknown options \"$name\"!!!\n");
	exit(1);
	}

        if ($val eq '') {
                &myprint(
               "Options \"$name\" not found. Using default \"$default\"\n");
                return $default;
        }

	&myprint("Options \"$name\" set to $val\n");
	$val;
}

#
# Find the config file which fit the best our system
#
sub findConfig {

	#
	# first, what do we have...
	#
	@configs = <${configDir}/*.conf>;
	foreach $file (@configs) {
		$file =~ s/\.conf$//;
		$file =~ s/.*\///;

		($os, $vers, $arch) = split(/-/, $file);
		@vers = split(/\./, $vers);

		# Let see how close is the filename from our system
		# First the OS name has to be the same, then version numbers,
		# then architecture

		$match = 0;
		$match += 0x1000000 if ($OSname =~ /$os/);

		$match += 0x0800000 if ($vers[0] == $OSversion[0]);
		$match += 0x0400000 if ($vers[0] < $OSversion[0]);
		$match += 0x0200000 if ($vers[0] > $OSversion[0]);
		$match += 0x0080000 if ($vers[1] == $OSversion[1]);
		$match += 0x0040000 if ($vers[1] < $OSversion[1]);
		$match += 0x0020000 if ($vers[1] > $OSversion[1]);
		$match += 0x0008000 if ($vers[2] == $OSversion[2]);
		$match += 0x0004000 if ($vers[2] < $OSversion[2]);
		$match += 0x0002000 if ($vers[2] > $OSversion[2]);

		$match += 0x0000001 if ($OSarch =~ /$arch/);
		$myChoise = $file
			if ($match > $oldmatch && $match >= 0x1000000);
		$oldmatch = $match;
	}
	&myprint("Looking for a template file in ", join(' ', @configs), "\n");

	if ($myChoise) {
		&myprint("The best choise seems to be \"$myChoise.conf\"\n");
	} else {
		&myprint("WARNING: NO configuration found. Using default".
			" \"$defaultConfigFile\"\n");
		$myChoise = $defaultConfigFile;
	}
	"$configDir/$myChoise.conf";
}

#
# Consistency check. Any kind of checking
#
sub checkConfig {

	#
	# A problem with PROTO_INET KRT_RT_SOCK PROTO_ICMP
	#
	if ($options{'PROTO_INET'} && !$options{'KRT_RT_SOCK'}) {
		if (!$options{'PROTO_ICMP'}) {
			&myprint(
	"WARNING: PROTO_INET is defined and your system does not support\n",
	"WARNING: routing socket (option KRT_RT_SOCK). The ICMP protocol\n",
	"WARNING: has to be set. Setting ICMP...\n");
			$options{'PROTO_ICMP'} = 1;
		}
	}

	#
	# If KVM_xxx is not guessed the library list may be wrong.
	# So let get a few symbols, just in case, to set the library flag.
	#
	if (!$options{'KVM_TYPE_NONE'}) {
		&getSymbol('kvm_open:kvm_openfiles', '.');
		&getSymbol('kvm_geterr', '.');
	}
	&getSymbol('socket', '.');
}

#
# Print a Config file
#
sub printConfig {
	local($Config) = $_[0];

	&myprint("\nCreating configuration file \"$Config\"\n");
	open(CONFIG, ">$Config") || die(
		"ERROR: Cannot open \"$Config\": $!\n" .
		"ERROR: Aborting...\n");

	#
	# Justr print everything from %proto, %unixCmd, %cmdFlags,
	# %dirPath, %miscParam, %runtimePath, %options, %fileList
	#
	print CONFIG "protocols ", join(' ', @protocols), "\n\n";

	foreach $item (keys(%unixCmd)) {
		printf CONFIG "%-20s %s\n", $item, $unixCmd{$item}
			if ($unixCmd{$item} ne $unixCmdDefault{$item});
	}
	print CONFIG "\n\n";
	foreach $item (keys(%cmdFlags)) {
		printf CONFIG "%-20s %s\n",  $item, $cmdFlags{$item}
			if ($cmdFlags{$item} ne $cmdFlagsDefault{$item});
	}
        print CONFIG "\n\n";
        foreach $item (keys(%dirPath)) {
                printf CONFIG "%-20s %s\n",  $item, $dirPath{$item}
			if ($dirPath{$item} ne $dirPathDefault{$item});
        }
        print CONFIG "\n\n";
        foreach $item (keys(%miscParam)) {
                printf CONFIG "%-20s %s\n",  $item, $miscParam{$item}
			if ($miscParam{$item} ne $miscParamDefault{$item});
        }
        print CONFIG "\n\n";
        foreach $item (keys(%runtimePath)) {
                printf CONFIG "%-20s %s\n",  $item, $runtimePath{$item}
			if ($runtimePath{$item} ne $runtimePathDefault{$key});
        }
        print CONFIG "\n\n";
        foreach $item (keys(%options)) {
		#
		# Any option generated from the 'protocol' statement should
		# not show up on the options list.
		#
		next if (&IsInProtoList($item));

		if ($options{$item} == 1 &&
				$options{$item} != $optionsDefault{$item}) {
			printf CONFIG "options %s\n", $item;
		} elsif ($options{$item} &&
				$options{$item} ne $optionsDefault{$item}) {
			#
			# If the option has space or is enclosed by "", then
			# enclose it by ""
			#
			if ($options{$item} =~ / / ||
					$options{$item} =~ /^".*"$/) {
				printf CONFIG
					"options $item=\"$options{$item}\"\n";
			} else {
				printf CONFIG
					"options $item=$options{$item}\n";
			}
		}
	}
	close(CONFIG);
}

#
# find out if an option is defined from the protocol statement (i.e. is
# in the protocols array or dependents
#
sub IsInProtoList  {
	local($item) = @_;
	local($proto);

	foreach $proto (@protocols) {
		return(1) if ($proto{$proto} =~ /$item/);
	}
	return(0);
}

#
# Ask for an answer. Set default value
#
sub Ask {
	local($question, $default) = @_;
	local($ans);

	print $question;
	print LOG $question if ($doLog);
	$ans = <>; chop $ans;
	print LOG "$ans\n" if ($doLog);

	($ans)? $ans: $default;
}

#
# Get a symbol from a library
#
sub getSymbol {
	local($symb, $type) = @_;
	local($dir, $file);

	#
	# Go through all known libraries, get all symbols!
	#
	if (!$gsDone || !$symb) {
		foreach $dir (@libDir) {
			foreach $file (@libFiles) {

				next if (!-e "$dir/lib$file.a");

				&myprint(
				     "Checking symbols in $dir/lib$file.a... ");

				open(NM, $unixCmd{"nm"}." -p $dir/lib$file.a |")
					|| die("ERROR: cannot execute ".
					$unixCmd{"nm"}. " -p $dir/lib$file.a".
					": $!\nERROR: Aborting...\n");
				while(<NM>) {
					chop;
                        		/\s([_a-zA-Z0-9]+)$/ && do {
                                		$gsSymbol{$1} = $file
							unless($gsSymbol{$1});
					};
				}
				&myprint("Done\n");
				close(NM);
                        }
                }
		#
		# A trick to check if the symbol should start with '_'
		#
		$startSymbol = ($gsSymbol{"fopen"})? '': '_';

		#
		# Get the macro (#define) symbols. (yuk!)
		#
		foreach $dir (@includeDir) {
			&myprint("Checking macro in $dir... ");
			while(<*.h>) {
				$hdr = $_;
				open(HDR, $hdr) || next;
				while(<HDR>) {
					/^\s*#define\s+(\w+)\([^\)]*\)/ && do {
						$gsMacro{$1} .= $hdr;
						next;
					};
				}
				close(HDR);
			}
			&myprint("Done\n");
		}
                $gsDone = 1;
	}

	#
	# The first partameter is a list of symbols separated by ':'
	#
	@symbs = split(/:/, $symb);
	foreach $symb (@symbs) {
		#
		# Add the library to the ldflags unless it is libc.a
		#
		if ($lib = $gsSymbol{"$startSymbol$symb"}) {
			$cmdFlags{'ldflags'} .= " -l$lib" if ($lib ne 'c' &&
				$cmdFlags{'ldflags'} !~ /-l$lib/);
			return($symb);
		}
	}

	#
	# The symbol may be a macro (#define).
	#
	foreach $symb (@symbs) {
		return($symb) if ($gsMacro{$symb});
	}
	'';
}

#
# Get a symbol from the kernel table.
#
sub getKernSymbol {
	local($symb, $type) = @_;

	#
	# Run nm on the kernel file. Store all the symbols. They'll be
	# used later.
	#
	if (!$gksDone || !symb) {
		&myprint("Checking symbols in ", $runtimePath{"path_unix"},
			"... ");
		open(NM, $unixCmd{"nm"}." -p ".$runtimePath{"path_unix"}."|") ||
			die("\nERROR: cannot execute ".$unixCmd{"nm"}.
			    " -p ".$runtimePath{"path_unix"}.": $!\n".
			    "ERROR: Aborting...\n");
		while(<NM>) {
			/\s([_a-zA-Z0-9]+)$/ && do {
				$gksSymbol{$1} = 1;
				next;
			};
		}
		$gksDone = 1;
		close(NM);
		&myprint("Done.\n");
	}

	#
	# The first partameter is a list of symbols separated by ':'
	#
	@symbs = split(/:/, $symb);
	foreach $symb (@symbs) {
		return $symb if ($gksSymbol{$symb});
	}
	'';
}


#
# Find an include file
#
sub findInclude {
	local($hdr) = @_;

	foreach $dir (@includeDir) {
		if (-e "$dir/$hdr") {
			return "$dir/$hdr";
		}
	}
	'';
}

#
# Grep an header file to see if a #define is defined :)
#
sub getDefine {
	local($define, $file) = @_;
	local($val, @files) = '';

	@files = split(/:/, $file);
	foreach $file (@files) {

		next if (!($file = &findInclude($file)));

		open(HDR, $file) || die(
			"ERROR: cannot open include file \"$file\": $!\n".
			"ERROR: Aborting\n");
		while(<HDR>) {
			(/^\s*#define\s+${define}\s*$/ ||
			/^\s*#define\s+${define}\s+/) && do {
				$val = $define;
				last;
			}
		}
		close(HDR);
		return $val if ($val);
	}
	'';
}

#
# Save the default values, used for printConfig()
#
sub saveDefault {
	foreach $key (keys(%unixCmd)) {
		$unixCmdDefault{$key} = $unixCmd{$key};
	}
	foreach $key (keys(%cmdFlags)) {
		$cmdFlagsDefault{$key} = $cmdFlags{$key};
	}
	foreach $key (keys(%dirPath)) {
		$dirPathDefault{$key} = $dirPath{$key};
	}
	foreach $key (keys(%miscParam)) {
		$miscParamDefault{$key} = $miscParam{$key};
	}
	foreach $key (keys(%runtimePath)) {
		$runtimePathDefault{$key} = $runtimePath{$key};
	}
	foreach $key (keys(%options)) {
		$optionsDefault{$key} = $options{$key};
	}
}

#
# Open a log file.
#
sub setLog {
	open(LOG, ">$logFile") || die(
		"ERROR: cannot open logging file \"$logFile\": $!".
		"ERROR: Aborting...");

	$doLog = 1;
}

#
# Log something to screen and log file
#
sub myprint {
	print @_;
	print LOG @_ if ($doLog);
}

sub basename {
	$_[0] =~ s#.*/##;
	$_[0];
}
